unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, ComCtrls, StdCtrls, StdActns, ActnList, Menus, Mask,
  ExtCtrls, ShellApi, jpeg, Grids;

Type

  Tlabels1 = array [1..22] of Tlabel;
  TLabels4 = array [1..4,1..4] of TLabel;
  TEdits4 = array [1..4,1..4] of TEdit;
  TLabels8 = array [4..15,1..8] of TLabel;
  TEdits8 = array [4..15,1..8] of TEdit;

  TMainForm = class(TBaseForm)
                                            {Menu bar}
    ActionList1: TActionList;
    InputOpen: TAction;
    InputSave: TAction;
    OutputOpen: TAction;
    GraphOpen: TAction;
    GraphSave: TAction;
    FilePrint: TAction;
    GroupSave: TAction;
    GroupOpen: TAction;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    InputOpen1: TMenuItem;
    OpenOutput1: TMenuItem;
    GraphOpen1: TMenuItem;
    ProgramExit1: TMenuItem;
    Edit: TMenuItem;
    Cut: TMenuItem;
    CopyIt: TMenuItem;
    Paste: TMenuItem;
    DeleteIt: TMenuItem;
    FilePrint1: TMenuItem;
    OpenGroup: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditDelete1: TEditDelete;
    EditPaste1: TEditPaste;
    FileExit1: TFileExit;
    PageControl1: TPageControl;
    InputOpen_Dialog: TOpenDialog;
    GraphOpen_Dialog: TOpenDialog;
    GraphSave_Dialog: TSaveDialog;
    GroupOpen_Dialog: TOpenDialog;
    InputSave_Dialog: TSaveDialog;
    OutputOpen_Dialog: TOpenDialog;
    GroupSave_Dialog: TSaveDialog;
                                             {Intro tabsheet}
    Intro_Tabsheet: TTabSheet;
    Intro_Memo: TMemo;
    LogoImage: TImage;
                                            {Input tabsheet}
    Input_TabSheet: TTabSheet;
    Filesave_Button: TButton;
    FileOpen_Button: TButton;
    KrHelpButton: TButton;
    InputSymbols_Button: TButton;
    Title1_Edit: TEdit;
    Title2_Edit: TEdit;
    Edit1_1: TEdit;
    Edit2_1: TEdit;
    Edit2_3: TEdit;
    Edit2_4: TEdit;
    Edit16_1: TEdit;
    Edit16_2: TEdit;
    Edit16_3: TEdit;
    Edit16_4: TEdit;
    Edit16_5: TEdit;
    Edit16_6: TEdit;
    Edit17_1: TEdit;
    Edit17_2: TEdit;
    Edit17_3: TEdit;
    Edit17_4: TEdit;
    Edit17_5: TEdit;
    Edit17_6: TEdit;
    Edit18_2: TEdit;
    Edit18_3: TEdit;
    Edit18_4: TEdit;
    Edit18_5: TEdit;
    Edit18_1: TEdit;
    Edit19_1: TEdit;
    Edit19_2: TEdit;
    Edit19_3: TEdit;
    Edit19_4: TEdit;
    Edit19_5: TEdit;
    Edit20_1: TEdit;
    Edit20_2: TEdit;
    Edit20_3: TEdit;
    Edit21_1: TEdit;
    Edit21_2: TEdit;
    ExplainEdit1: TEdit;
    ExplainEdit2: TEdit;
    Filename_Label: TLabel;
    Title1_Label: TLabel;
    Title2_Label: TLabel;
    Label1_2: TLabel;
    Label1_1: TLabel;
    Label1_3: TLabel;
    Label1_4: TLabel;
    Label1_5: TLabel;
    Label1_6: TLabel;
    Label2_1: TLabel;
    Label2_3: TLabel;
    Label2_4: TLabel;
    Label2_2: TLabel;
    Label16_1: TLabel;
    Label16_2: TLabel;
    Label16_3: TLabel;
    Label16_4: TLabel;
    Label16_5: TLabel;
    Label16_6: TLabel;
    Label17_1: TLabel;
    Label17_2: TLabel;
    Label17_3: TLabel;
    Label17_4: TLabel;
    Label17_5: TLabel;
    Label17_6: TLabel;
    Label18_1: TLabel;
    Label18_2: TLabel;
    Label18_3: TLabel;
    Label18_4: TLabel;
    Label18_5: TLabel;
    Label19_1: TLabel;
    Label19_2: TLabel;
    Label19_3: TLabel;
    Label19_4: TLabel;
    Label19_5: TLabel;
    Label20_1: TLabel;
    Label20_2: TLabel;
    Label20_3: TLabel;
    Label21_1: TLabel;
    Label21_2: TLabel;
    ExplainLabel1: TLabel;
    ExplainLabel2: TLabel;
    ScrollBox1: TScrollBox;
    Combo2: TComboBox;
    Combo3: TComboBox;
    Combo4: TComboBox;
    Combo5: TComboBox;
    Combo6: TComboBox;
    ComboKy: TComboBox;
                                            {Figure tabsheet}
    Figure_TabSheet: TTabSheet;
    Figure_Image: TImage;
                                            {Output tabsheet}
    Output_TabSheet: TTabSheet;
    OutputFile_Button: TButton;
    OutputSymbols_Button: TButton;
    Group_Button: TButton;
    Go_Button: TButton;
    Cancel_Button: TButton;
    GroupOpenButton: TButton;
    ViewGraph_Button: TButton;
    SaveGroupButton: TButton;
    SaltImage1: TImage;
    Output_Memo: TMemo;
    WaitMemo: TMemo;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton12: TRadioButton;
                                           {Graphics tabsheet}
    Graphics_TabSheet: TTabSheet;
    OutputFileButton: TButton;
    GroupFileButton: TButton;
    SaveGraph_Button: TButton;
    SeeGraphButton: TButton;
    ShowSymbolsButton: TButton;
    CloseOutput_Button: TButton;
    GraphImage: TImage;
    SaltImage2: TImage;
    FileNameLabel: TLabel;
    FigureButton: TButton;
    ModernLabel: TLabel;
        {General}
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Intro_TabsheetShow(Sender: TObject);
    procedure FilePrint_Execute(Sender: TObject);
        {Input}
    procedure Input_TabSheetShow(Sender: TObject);
    procedure EditEnter(Sender: TObject);
    procedure ComboEnter(Sender: TObject);
    procedure CmaxMemoClick(Sender: TObject);
    procedure ComboNrOfSeasonsChange(Sender: TObject);
    procedure ComboNrOfSeasonsExit(Sender: TObject);
    procedure ComboKdIndexChange(Sender: TObject);
    procedure ComboKdIndexExit(Sender: TObject);
    procedure ComboKfIndexExit(Sender: TObject);
    procedure ComboKfIndexChange(Sender: TObject);
    procedure EditNrOfYearsExit(Sender: TObject);
    procedure CAmaxExit(Sender: TObject);
    procedure EditCBmaxExit(Sender: TObject);
    procedure ComboAnnualIndexExit(Sender: TObject);
    procedure EditSeasonDurationExit(Sender: TObject);
    procedure EditIrrAreaExit(Sender: TObject);
    function  StringToFloat(Str : string) : double;
    procedure EditPumpingExit(Sender: TObject);
    procedure EditPumpingChange(Sender: TObject);
    procedure KrHelpButton_Click(Sender: TObject);
    procedure InputSymbols_ButtonClick(Sender: TObject);
    procedure InputOpen_Execute(Sender: TObject);
    procedure InputSave_Execute (Sender: TObject);
        {Figure}
    procedure Figure_TabSheetShow(Sender: TObject);
    procedure FigureButtonClick(Sender: TObject);
        {Output}
    procedure Output_TabSheetShow(Sender: TObject);
    procedure OutputOpen_Execute(Sender: TObject);
    procedure CloseOutput_ButtonClick(Sender: TObject);
    procedure GroupOpen_Execute(Sender: TObject);
    procedure OutputSymbols_ButtonClick(Sender: TObject);
    procedure Group_ButtonClick(Sender: TObject);
    procedure Go_ButtonClick(Sender: TObject);
    procedure Cancel_ButtonClick(Sender: TObject);
    procedure GroupSave_Execute (Sender: TObject);
    procedure ViewGraph_ButtonClick(Sender: TObject);
         {Graphics}
    procedure Graphics_TabSheetShow(Sender: TObject);
    procedure GraphOpen_Execute(Sender: TObject);
    procedure GraphSave_Execute(Sender: TObject);
    procedure ShowSymbolsButtonClick(Sender: TObject);
        {Finish}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
       {Input}
    NoSave, OutputOpened,
    InputOpened, GraphOpened,
    GroupOpened, RunTimeError,
    RunTimeWarning           : boolean;
    Label1A                  : Tlabels1;    {array van TLabel1}
    Label4A                  : TLabels4;    {array van TLabel4}
    Edit4A                   : TEdits4;     {array van TEdit4}
    Label8A                  : TLabels8;    {array van TLabel8}
    Edit8A                   : TEdits8;     {array van TEdit8}
       {Input}
    procedure MakeStrings;
    procedure AdjustScreen;
    procedure MakeValues;
    function  SetAndVerifySaveName : boolean;
    function  SetAndVerifyGroupName : boolean;
    procedure HideEdits;
    procedure ShowEdits;
    procedure DoCalculations;
    procedure AnnualMessages;
       {Output}
    procedure ShowOutputGroup(const GroupSign : string);
      {Graphics}
    procedure ShowGraphics;
      {General}
    procedure SetInitialDir (AuxDir:string);

  public
    InitDir, DataFile,
    OriginalDir, DataDir : string;
    NrOfErrorLines, NrOfWarningLines : integer;
    FirstYear, AllZero : boolean;
    InitDecSep : Char;

  end;

var
  MainForm: TMainForm;

implementation

uses UDataMod, UCloseForm, UCalculate,UExtraUtils, UHelpForm,
     UInputSymbolsForm, UOutputSymbolsForm, UWarningForm;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
{----------------------------------------------}
var i,j,k : integer; HlpVar : string;
begin
  inherited;
  PageControl1.ActivePageIndex := 0;     {Introduction tabsheet}
  Scrollbox1.VertScrollBar.Position:=0;
  InitDir:=Getcurrentdir;
  SetInitialDir (InitDir);
  InputSave.Enabled := false;
  OutputOpened := false;
  GroupOpened := false;
  InputOpened := false;
  GraphOpened := false;
  WarnedKY:=false;
  WarnedInit:=false;
  WarnedRota:=false;
  Done:=false;
  Fixed:=false;
  for k:=1 to 4 do
  begin
    Warn1[k]:=false;
    Warn2[k]:=false;
  end;
  FirstYear:=true;
  for k:=1 to 22 do                         {Line numbers}
  begin
    Label1A[k] := TLabel.Create(self);
    Label1A[k].Parent := ScrollBox1;
    Label1A[k].Left := 8;
    Label1A[k].Width := 8;
    Label1A[k].Height := 16;
    Label1A[k].Top := 27+(k-1)*48;
    HlpVar := IntToStr (k);
    if k<22 then Label1A[k].Caption := HlpVar
    else
    begin
       Label1A[k].Top := 1015;
       Label1A[k].Caption := 'end';
    end;
  end;

  for j:=1 to 4 do for k:=1 to 4 do        {seasonal variables}
  begin                                {placed seperately on MainForm}
    HlpVar := IntToStr(k);
    Label4A[j,k] := TLabel.Create(self);
    Edit4A[j,k] := TEdit.Create(self);
    Label4A[j,k].Parent := ScrollBox1;
    Edit4A[j,k].Parent := ScrollBox1;
    Label4A[j,k].Width := 40;
    Edit4A[j,k].Width := 57;
    Label4A[j,k].Height := 13;
    Edit4A[j,k].Height := 24;
    Edit4A[j,k].OnEnter := EditEnter;

    if j<3 then
    begin
      Label4A[j,k].Left := 40 + (k-1)*72;
      Edit4A[j,k].Left := 40 + (k-1)*72;
      if k<3 then
      begin
        if j=1 then Edit4A[j,k].Text := '6';     {duration of seasons}
        if j=2 then Edit4A[j,k].Text := '0.8';   {FsU}
      end else
      begin
        Label4A[j,k].Enabled := false;
        if j=1 then Edit4A[j,k].Text := '-1';
        Edit4A[j,k].Enabled := false;
        if j=2 then Edit4A[j,k].Text := '-1';
      end;
      if j=1 then
      begin
        Label4A[j,k].Top := 104;
        Edit4A[j,k].Top := 120;
        Label4A[j,k].Caption := ('Ts'+HlpVar);
        Label4A[j,k].Hint := ('Duration of season '+HlpVar+
                              ' in months, integer');
        Edit4A[j,k].Hint := Label4A[j,k].Hint;
        Edit4A[j,k].OnEnter := EditEnter;
      end else
      begin
        Label4A[j,k].Top := 104+8*48;
        Edit4A[j,k].Top := 120+8*48;
        Label4A[j,k].Caption := ('FsU'+HlpVar);
        Label4A[j,k].Hint := ('Storage efficiency in season '+HlpVar+
             ' of rain water in the root zone of the  un-irrigated'+
             ' (U) land, 0 < FsU < 1');
        Edit4A[j,k].Hint := Label4A[j,k].Hint;
      end;
    end; {if j<3 then}

    if j=1 then
       Edit4A[j,k].OnExit := EditSeasonDurationExit;

    if j=3 then
    begin
      Label4A[j,k].Left := 256 + (k-1)*72;
      Edit4A[j,k].Left := 256 + (k-1)*72;
      Label4A[j,k].Top := 920;
      Edit4A[j,k].Top := 936;
      Label4A[j,k].Caption := 'SDu'+HlpVar;
      Edit4A[j,k].Text := '0';
      Label4A[j,k].Hint :=
        ('Subsurface drainage water used for irrigation in season '
        +HlpVar+'  (m3/season per m2 total area),  SDu'+HlpVar+' < Gd');
      Edit4A[j,k].Hint := Label4A[j,k].Hint;
      if k>2 then
      begin
        Label4A[j,k].Enabled := false;
        Edit4A[j,k].Enabled := false;
        Edit4A[j,k].Text := '-1';
      end;
    end; {if j=3 then}

    if j=4 then
    begin
      Label4A[j,k].Left := 184 + (k-1)*72;
      Edit4A[j,k].Left := 184 + (k-1)*72;
      Label4A[j,k].Top := 968;
      Edit4A[j,k].Top := 984;
      Label4A[j,k].Caption := 'Frd'+HlpVar;
      Edit4A[j,k].Text := '0';
      Label4A[j,k].Hint :=
        ('Reduction factor of the drainage function for water table'+
        ' control or  for partial drainage of the area in season '
         +HlpVar+' (-)');
      Edit4A[j,k].Hint := Label4A[j,k].Hint;
      if k>2 then
      begin
        Label4A[j,k].Enabled := false;
        Edit4A[j,k].Enabled := false;
        Edit4A[j,k].Text := '-1';
      end;
    end; {if j=4 then}

  end; {for j:=1 to 4 do for k:=1 to 4 do}

  for i:=4 to 15 do for k:=1 to 8 do
  begin
    if i<>11 then
    begin
      Label8A[i,k] := TLabel.Create(self);
      Edit8A[i,k] := TEdit.Create(self);
      Label8A[i,k].Parent := ScrollBox1;
      Edit8A[i,k].Parent := ScrollBox1;
      Label8A[i,k].Left := 40 + (k-1)*72;
      Edit8A[i,k].Left := 40 + (k-1)*72;
      Label8A[i,k].Top := 152 + (i-4)*48;
      Edit8A[i,k].Top := 168 + (i-4)*48;
      Label8A[i,k].Width := 40;
      Edit8A[i,k].Width := 57;
      Label8A[i,k].Height := 13;
      Edit8A[i,k].Height := 24;
      Edit8A[i,k].Text := '0';
    end;
  end; {for i:=4 to 15 do for k:=1 to 8 do}

  Edit1_1.Visible := true;
  Edit1_1.Enabled := true;

  Combo2.OnEnter  := ComboEnter;
  Combo2.OnChange := ComboNrOfSeasonsChange;
  Combo2.OnExit   := ComboNrOfSeasonsExit;
  Combo3.OnEnter  := ComboEnter;
  Combo3.OnExit   := ComboKdIndexExit;
  Combo3.OnChange := ComboKdIndexChange;
  Combo4.OnEnter  := ComboEnter;
  Combo4.OnExit   := ComboKfIndexExit;
  Combo4.OnChange := ComboKfIndexChange;
  Combo5.OnEnter  := ComboEnter;
  Combo6.OnEnter  := ComboEnter;
  ComboKy.OnEnter := ComboEnter;

  Label16_1.Top := 152+576;
  Edit16_1.Top := 152+592;
  Edit16_1.OnEnter := EditEnter;
  Label16_2.Top := 152+576;
  Edit16_2.Top := 152+592;
  Edit16_2.OnEnter := EditEnter;
  Label16_3.Top := 152+576;
  Edit16_3.Top := 152+592;
  Edit16_3.OnEnter := EditEnter;
  Label16_4.Top := 152+576;
  Edit16_4.Top := 152+592;
  Edit16_4.OnEnter := EditEnter;
  Label16_5.Top := 152+576;
  Edit16_5.Top := 152+592;
  Edit16_5.OnEnter := EditEnter;
  Label16_6.Top := 152+576;
  Edit16_6.Top := 152+592;
  Edit16_6.OnEnter := EditEnter;
  Label17_1.Top := 152+624;
  Edit17_1.Top := 152+640;
  Edit17_1.OnEnter := EditEnter;
  Label17_2.Top := 152+624;
  Edit17_2.Top := 152+640;
  Edit17_2.OnEnter := EditEnter;
  Label17_3.Top := 152+624;
  Edit17_3.Top := 152+640;
  Edit17_3.OnEnter := EditEnter;
  Label17_4.Top := 152+624;
  Edit17_4.Top := 152+640;
  Edit17_4.OnEnter := EditEnter;
  Label17_5.Top := 152+624;
  Edit17_5.Top := 152+640;
  Edit17_5.OnEnter := EditEnter;
  Label17_6.Top := 152+624;
  Edit17_6.Top := 152+640;
  Edit17_6.OnEnter := EditEnter;
  Label18_1.Top := 152+672;
  Edit18_1.Top := 152+688;
  Edit18_1.OnEnter := EditEnter;
  Label18_2.Top := 152+672;
  Edit18_2.Top := 152+688;
  Edit18_2.OnEnter := EditEnter;
  Label18_3.Top := 152+672;
  Edit18_3.Top := 152+688;
  Edit18_3.OnEnter := EditEnter;
  Label18_4.Top := 152+672;
  Edit18_4.Top := 152+688;
  Edit18_4.OnEnter := EditEnter;
  Label18_5.Top := 152+672;
  Edit18_5.Top := 152+688;
  Edit18_5.OnEnter := EditEnter;
  Label19_1.Top := 152+720;
  Edit19_1.Top := 152+736;
  Edit19_1.OnEnter := EditEnter;
  Label19_2.Top := 152+720;
  Edit19_2.Top := 152+736;
  Edit19_2.OnEnter := EditEnter;
  Label19_3.Top := 152+720;
  Edit19_3.Top := 152+736;
  Edit19_3.OnEnter := EditEnter;
  Label19_4.Top := 152+720;
  Edit19_4.Top := 152+736;
  Edit19_4.OnEnter := EditEnter;
  Label19_5.Top := 152+720;
  Edit19_5.Top := 152+736;
  Edit19_5.OnEnter := EditEnter;
  Label20_1.Top := 152+768;
  Edit20_1.Top := 152+784;
  Edit20_1.OnEnter := EditEnter;
  Label20_2.Top := 152+768;
  Edit20_2.Top := 152+784;
  Edit20_2.OnEnter := EditEnter;
  Label20_3.Top := 152+768;
  Edit20_3.Top := 152+784;
  Edit20_3.OnEnter := EditEnter;
  Label21_1.Top := 152+816;
  Edit21_1.Top := 152+832;
  Edit21_1.OnEnter := EditEnter;
  Label21_2.Top := 152+816;
  Edit21_2.Top := 152+832;
  Edit21_2.OnEnter := EditEnter;

  i:=0;
  k:=1;
  for j:=4 to 15 do if j<>11 then        {seasonal variables placed}
  begin                                   {in a group on MainForm}
    while k<9 do
    begin
      Edit8A[j,k].OnEnter := EditEnter;
      Edit8A[j,k+1].OnEnter := EditEnter;
      inc(i);
      HlpVar := IntToStr (i);

      if j=4 then
      begin
        Label8A[j,k].Caption := ('A'+HlpVar);
        Label8A[j,k+1].Caption := ('B'+HlpVar);
        Label8A[j,k].Hint :=
          ('Irrigated A area (under group A crops) during season '
           +HlpVar+' as a fraction  of total area (0 <= A <= 1)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint :=
          ('Irrigated B area (under group B crops) during season '
           +HlpVar+' as a fraction  of total area (0 <= B <= 1)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
        Edit8A[j,k].Text := '0.4';
        Edit8A[j,k+1].Text := '0.3';
        Edit8A[j,k].OnExit := EditIrrAreaExit;
        Edit8A[j,k+1].OnExit := EditIrrAreaExit;
      end;

      if j=5 then
      begin
        Label8A[j,k].Caption := ('RcA'+HlpVar);
        Label8A[j,k+1].Caption := ('RcB'+HlpVar);
        Label8A[j,k].Hint :=
          ('Whether in season '+HlpVar+' area A is under a' +
           ' sumberged rice crop (paddy):    1 = Yes,  0 = No');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint :=
          ('Whether in season '+HlpVar+' area B is under a' +
           ' sumberged rice crop (paddy):    1 = Yes,  0 = No');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=6 then
      begin
        Label8A[j,k].Caption := ('PLc'+HlpVar);
        Label8A[j,k+1].Caption := ('IRo'+HlpVar);
        Label8A[j,k].Hint :=
          ('Percolation losses from the irrigation canal system' +
           ' in season '+HlpVar+'       (m3/season per m2 total area)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint :=
          ('Water leaving the area through the irrigation canal'+
           ' system (bypass) in season '+HlpVar+
           ' (m3/season per m2 total area)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=7 then
      begin
        Label8A[j,k].Caption := ('IaA'+HlpVar);
        Label8A[j,k+1].Caption := ('EpA'+HlpVar);
        Label8A[j,k].Hint :=
          ('Amount of surface irrigation water applied to type A area' +
           ' in season '+HlpVar+'         (m3/season per m2 irrigated' +
           ' area under group A crops)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint :=
          ('Potential evaporation from irrigated land under group' +
           ' A crops in      season '+HlpVar+
           ' (m3/season per m2 irrigated area under group A crops)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=8 then
      begin
        Label8A[j,k].Caption := ('IaB'+HlpVar);
        Label8A[j,k+1].Caption := ('EpB'+HlpVar);
        Label8A[j,k].Hint :=
          ('Amount of surface irrigation water applied to type B area' +
           ' in season '+HlpVar+'         (m3/season per m2 irrigated' +
           ' area under group B crops)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint :=
          ('Potential evaporation from irrigated land under group' +
           ' B crops in      season '+HlpVar+
           ' (m3/season per m2 irrigated area under group B crops)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=9 then
      begin
        Label8A[j,k].Caption := ('Prec'+HlpVar);
        Label8A[j,k+1].Caption := ('EpU'+HlpVar);
        Label8A[j,k].Hint :=
          ('Precipitation (rainfall) in season '+HlpVar+
           ' (m3/season per m2 total area)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint :=
          ('Potential evaporation from the un-irrigated (U) land ' +
           ' in season ' +HlpVar+
           '     (m3/season per m2 un-irrigated (U) area)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=10 then
      begin
        Label8A[j,k].Caption := ('FsA'+HlpVar);
        Label8A[j,k+1].Caption := ('FsB'+HlpVar);
        Label8A[j,k].Hint := ('Storage efficiency of rain and irrigation'+
        ' water in the root zone of   the type A land under group A crops,'+
        ' during season '+HlpVar+',  0 < FsA < 1');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint := ('Storage efficiency of rain and irrigation'+
        ' water in the root zone of   the type B land under group B crops,'+
        ' during season '+HlpVar+',  0 < FsA < 1');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=12 then
      begin
        Label8A[j,k].Caption := ('GWi'+HlpVar);
        Label8A[j,k+1].Caption := ('GWo'+HlpVar);
        Label8A[j,k].Hint := ('Incoming ground water flow through'+
        ' the aquifer in season '+HlpVar+
        ' (m3/season per m2 total area)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint := ('Outgoing ground water flow through'+
        ' the aquifer in season '+HlpVar+
        ' (m3/season per m2 total area)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=13 then
      begin
        Label8A[j,k].Caption := ('SiU'+HlpVar);
        Label8A[j,k+1].Caption := ('SoU'+HlpVar);
        Label8A[j,k].Hint := ('Incoming surface runoff into the'+
        ' un-irrigated land during season '+HlpVar+
        '    (m3/season per m2 un-irrigated area)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint := ('Surface runoff from the un-irrigated'+
        ' (U) land during season '+HlpVar+
        '         (m3/season per m2 un-irrigated area)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=14 then
      begin
        Label8A[j,k].Caption := ('SoA'+HlpVar);
        Label8A[j,k+1].Caption := ('SoB'+HlpVar);
        Label8A[j,k].Hint := ('Surface drainage from the type A land '+
         ' in season '+HlpVar+
         '                    (m3/season per m2 area under group A crops)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint := ('Surface drainage from the type B land'+
         ' in season '+HlpVar+
         '                     (m3/season per m2 area under group B crops)');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
      end;

      if j=15 then
      begin
        Label8A[j,k].Caption := ('PGw'+HlpVar);
        Label8A[j,k+1].Caption := ('FPw'+HlpVar);
        Label8A[j,k].Hint := ('Ground water pumped from wells in the' +
         ' aquifer during season '+HlpVar+'         (m3/season per m2 total area)');
        Edit8A[j,k].Hint := Label8A[j,k].Hint;
        Label8A[j,k+1].Hint := ('Fraction of water pumped by wells from the'+
         ' aquifer during season '+HlpVar+'    used for irrigation'+
         ' (m3/season per m2 total area, 0 <= Fw <= 1');
        Edit8A[j,k+1].Hint := Label8A[j,k+1].Hint;
        Edit8A[j,k].OnExit := EditPumpingExit;
        Edit8A[j,k].OnChange := EditPumpingChange;
      end;

      if i>2 then
      begin
        Label8A[j,k].Enabled := false;
        Edit8A[j,k].Enabled := false;
        Edit8A[j,k].Text := '-1';
        Label8A[j,k+1].Enabled := false;
        Edit8A[j,k+1].Enabled := false;
        Edit8A[j,k+1].Text := '-1';
      end;

      k:=k+2;

    end; {while k<9 do}

    i:=0;
    k:=1;

  end; {for j:=4 to 15 do}

  InitDecSep := DecimalSeparator;

end;{TMainForm.FormCreate}
{------------------------}


{******************************************************************************
 Introduction TabSheet
 ******************************************************************************}

procedure TMainForm.Intro_TabsheetShow(Sender: TObject);
begin
  inherited;
  StatusText ('Use the Input tabsheet to continue');
  DataMod.CAMax:=8;
  DataMod.CBMax:=8;
  InputSave.Enabled := false;
end;


{******************************************************************************
 Input TabSheet
 ******************************************************************************}


procedure TMainForm.Input_TabSheetShow(Sender: TObject);
{------------------------------------------------------}
begin Inherited;
      Scrollbox1.VertScrollBar.Position:=0;
      StatusText('Enter data or use "Open" to see examples of input files in' +
            ' any folder or to edit existing files. Thereafter use' +
            ' "Save / run".');
      InputSave.Enabled := true;
      if not InputOpened then
      begin
        DataMod.Ns := 2;
        DataMod.Kd := 1;
        DataMod.Kf := 0;
        DataMod.Kr := 4;
        DataMod.Kw := 0;
        HideEdits;
      end;
end; {TMainForm.Input_TabSheetShow}
{--------------------------------}

{See also InputOpen_Execute in Group MenuBar Buttons}

procedure TMainForm.ComboNrOfSeasonsExit(Sender: TObject);
{-------------------------------------------------------}
begin
  inherited;
   DataMod.Ns := Combo2.ItemIndex+1;
{   ComboNrOfSeasonsChange (Sender); }
{   Input_Tabsheet.Show;  }
end;{TMainForm.CombotNrOfSeasonsExit}
{-----------------------------------}



procedure TMainForm.ComboNrOfSeasonsChange(Sender: TObject);
{----------------------------------------------------------}
var i, j, k,HlpInt:integer;
begin
  inherited;
    HlpInt:=Combo2.ItemIndex+1;
    Combo2.Text:=IntToStr(HlpInt);
    for j:=1 to 4 do for k:=1 to HlpInt do        {seasonal variables}
    begin
      Label4A[j,k].Enabled := true;
      Edit4A[j,k].Enabled := true;
    end;
    if HlpInt<4 then
    for j:=1 to 4 do for k:=HlpInt+1 to 4 do       {seasonal variables}
    begin
      Label4A[j,k].Enabled := false;
      Edit4A[j,k].Enabled := false;
    end;

    for j:=4 to 15 do if j<>11 then                  {seasonal variables}
    begin
     i:=0;
     k:=1;
     while k<9 do
     begin
       inc(i);
       if i<=HlpInt then
       begin
         Label8A[j,k].Enabled := true;
         Edit8A[j,k].Enabled := true;
         Label8A[j,k+1].Enabled := true;
         Edit8A[j,k+1].Enabled := true;
       end;
       if (HlpInt<4) and (i>HlpInt) then
       begin
         Label8A[j,k].Enabled := false;
         Edit8A[j,k].Enabled := false;
         Label8A[j,k+1].Enabled := false;
         Edit8A[j,k+1].Enabled := false;
       end;
       k:=k+2;
    end; {while k<9 do}
   end;
end; {TMainForm.ComboNrOfSeasonsChange}
{-------------------------------------}



procedure TMainForm.EditEnter(Sender: TObject);
{---------------------------------------------}
var MemoLine, MemoLine1, MemoLine2 : string;
begin Inherited;
      MemoLine := (Sender as Tedit).Hint;
      if length(MemoLine)>70 then
      begin
        MemoLine1 := copy(MemoLine,1,70);
        MemoLine2 := copy(MemoLine,71,length(MemoLine));
        ExplainEdit1.Visible := true;
        ExplainEdit1.Text := Memoline1;
        ExplainEdit2.Text := MemoLine2;
      end else
      begin
        ExplainEdit2.Text := MemoLine;
        ExplainEdit1.Visible := false;
      end;
end; {TMainForm.EditEnter}
{------------------------}



procedure TMainForm.ComboEnter(Sender: TObject);
{----------------------------------------------}
var MemoLine, MemoLine1, MemoLine2 : string;
begin
  inherited;
      MemoLine := (Sender as TComboBox).Hint;
      if length(MemoLine)>70 then
      begin
        MemoLine1 := copy(MemoLine,1,70);
        MemoLine2 := copy(MemoLine,71,length(MemoLine));
        ExplainEdit1.Visible := true;
        ExplainEdit1.Text := Memoline1;
        ExplainEdit2.Text := MemoLine2;
      end else
      begin
        ExplainEdit2.Text := MemoLine;
        ExplainEdit1.Visible := false;
      end;
end; {TMainForm.ComboEnter}
{-------------------------}


procedure TMainForm.CmaxMemoClick(Sender: TObject);
{-------------------------------------------------}
var MemoLine1, MemoLine2 : string;
begin
  inherited;
  MemoLine1:=' Maximum allowed soil salinity in area under A and/or B crops'+
             ' (see line 4)';
  MemoLine2:=' Only applicable under farmers responses (Kf=yes)';
  ExplainEdit1.Visible := true;
  ExplainEdit1.Text := Memoline1;
  ExplainEdit2.Text := MemoLine2;
end; {TMainForm.CmaxMemoClick}
{----------------------------}


procedure TMainForm.ComboKdIndexExit(Sender: TObject);
{----------------------------------------------------}
begin
  inherited;
   DataMod.Kd := Combo3.ItemIndex;
{   Input_Tabsheet.Show; }
end; {TMainForm.ComboKdIndexExit}
{-------------------------------}



procedure TMainForm.ComboKdIndexChange(Sender: TObject);
{------------------------------------------------------}
var k : Integer;
begin
  inherited;
   if Combo3.ItemIndex=0 then
   begin
     Label20_1.Enabled := false;
     Edit20_1.Enabled := false;
     Label20_2.Enabled := false;
     Edit20_2.Enabled := false;
     Label20_3.Enabled := false;
     Edit20_3.Enabled := false;
     Label21_1.Enabled := false;
     Edit21_1.Enabled := false;
     Label21_2.Enabled := false;
     Edit21_2.Enabled := false;
     for k:=1 to DataMod.Ns do
     begin
       Label4A[3,k].Enabled := false;
       Edit4A[3,k].Enabled := false;
       Label4A[4,k].Enabled := false;
       Edit4A[4,k].Enabled := false;
     end;
   end else
   begin
     Label20_1.Enabled := true;
     Edit20_1.Enabled := true;
     Label20_2.Enabled := true;
     Edit20_2.Enabled := true;
     Label20_3.Enabled := true;
     Edit20_3.Enabled := true;
     Label21_1.Enabled := true;
     Edit21_1.Enabled := true;
     Label21_2.Enabled := true;
     Edit21_2.Enabled := true;
     for k:=1 to DataMod.Ns do
     begin
       Label4A[3,k].Enabled := true;
       Edit4A[3,k].Enabled := true;
       Label4A[4,k].Enabled := true;
       Edit4A[4,k].Enabled := true;
     end;
     showmessage (' A drainage system is installed. Please check the data'+
                 ' in lines 20 and 21.');
   end;
end;{TMainForm.ComboKdIndexChange}
{--------------------------------}



procedure TMainForm.ComboKfIndexExit(Sender: TObject);
{----------------------------------------------------}
var PrevKf : integer;
begin
  inherited;
  PrevKf := DataMod.Kf;
  DataMod.Kf := Combo4.ItemIndex;
  if PrevKf<>DataMod.Kf then AdjustScreen;
end; {TMainForm.ComboKfIndexExit}
{-------------------------------}



procedure TMainForm.ComboKfIndexChange(Sender: TObject);
{------------------------------------------------------}
var PrevKf : Integer;
begin
  inherited;
  if Combo4.ItemIndex=1 then
    ShowEdits
  else
    HideEdits;
  PrevKf := DataMod.Kf;
  DataMod.Kf := Combo4.ItemIndex;
  if DataMod.Kf=1 then
  begin
//    ModernLabel.Visible:=false;
    Edit2_3.Visible:=true;
    Edit2_4.Visible:=true;
  end;
  if (PrevKf=0) and (DataMod.Kf=1) then AdjustScreen;
  if (PrevKf=1) and (DataMod.Kf=0) then AdjustScreen;
end; {TMainForm.ComboKfIndexChange}
{--------------------------------}



procedure TMainForm.EditNrOfYearsExit(Sender: TObject);
{-----------------------------------------------------}
begin
  inherited;
  DataMod.Ny := StrToInt(Edit2_1.Text);
  if DataMod.Ny>99 then
  begin
    Showmessage ('The number of years (Ny) for calculations must be'+
                 ' less than 100');
    Edit2_1.Text := '99';
    DataMod.Ny := 99;
  end;
end; {TMainForm.EditNrOfYearsExit}
{--------------------------------}


procedure TMainForm.CAmaxExit(Sender: TObject);
{---------------------------------------------}
begin
  inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
             ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '8';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
         begin
           Showmessage ('The maximum salinity cannot be negative');
           (Sender as TEdit).Text := '8';
           exit;
          end;
end; {TMainForm.CAmaxExit}
{------------------------}


procedure TMainForm.EditCBmaxExit(Sender: TObject);
{------------------------------------------------}
begin
  inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
             ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '8';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
         begin
           Showmessage ('The maximum salinity cannot be negative');
           (Sender as TEdit).Text := '8';
           exit;
          end;
end; {TMainForm.CBmaxExit}
{------------------------}


procedure TMainForm.ComboAnnualIndexExit(Sender: TObject);
{--------------------------------------------------------}
begin
  inherited;
  DataMod.Ky := ComboKy.ItemIndex;
  if DataMod.Ky=1 then
  begin
    Label1_4.Enabled := false;
    Combo4.Enabled := false;
    HideEdits;
  end else
  begin
    Label1_4.Enabled := true;
    Combo4.Enabled := true;
    if DataMod.Kf=1 then
    begin
      Label1_4.Enabled := true;
      Combo4.Enabled := true;
      Label1_6.Visible := true;
      Combo6.Visible := true;
      AdjustScreen;
    end;
  end;
end; {TMainForm.ComboAnnualIndexExit}
{-----------------------------------}



procedure TMainForm.EditSeasonDurationExit(Sender: TObject);
{----------------------------------------------------------}
var Yes: string; Well: real; How: integer;
begin Inherited;
      Try                             {test of het echt een integer is}
         (Sender as TEdit).Text :=
             IntToStr(StrToInt((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
             ((Sender as TEdit).Text + ' is not a valid integer');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if DataMod.Ns>1 then
      if (StrToInt((Sender as TEdit).Text)<1) or
         (StrToInt((Sender as TEdit).Text)>13-DataMod.Ns) then
         begin
           Well:= 12/DataMod.Ns;
           How:=trunc(Well);
           Yes:=IntToStr(How);
           Showmessage ('The duration of the season ranges from 1 to '+
                         IntToStr(13-DataMod.Ns));
           (Sender as TEdit).Text := Yes;
         end;
      if (DataMod.Ns=1) and (StrToInt((Sender as TEdit).Text)<>12) then
         begin
           Showmessage ('The duration of the season must be 12');
           (Sender as TEdit).Text := '12';
         end;
end; {TMainForm.EditSeasonDurationExit}
{-------------------------------------}



procedure TMainForm.EditIrrAreaExit(Sender: TObject);
{---------------------------------------------------}
begin Inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
             ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
         begin
           Showmessage ('The irrigated area fraction cannot be negative');
           (Sender as TEdit).Text := '0';
           exit;
         end;
      if (StringToFloat((Sender as TEdit).Text)>1) then
         begin
           Showmessage ('The irrigated area fraction cannot be greater' +
                        ' than unity');
           (Sender as TEdit).Text := '1';
         end;
      AdjustScreen;
end; {TMainForm.EditIrrAreaExit}
{------------------------------}



function TMainForm.StringToFloat(Str : string) : double;
{------------------------------------------------------}
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator := OldDecSep;
    end;
  end;
end; {TSegRegForm.StringToFloat}
{------------------------------}



procedure TMainForm.EditPumpingExit(Sender: TObject);
{---------------------------------------------------}
begin Inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
               ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
      begin
        Showmessage ('The Pumping from wells cannot be negative');
        (Sender as TEdit).Text := '0';
        exit;
      end;
      AdjustScreen;
end; {TMainForm.EditPumpingExit}
{------------------------------}



procedure TMainForm.EditPumpingChange(Sender: TObject);
{-------------------------------------------------------}
var HlpVar : real;
begin
  inherited;
    if ((Sender as TEdit).Text)='' then exit
    else
    Try
      HlpVar := StringToFloat ((Sender as TEdit).Text);          {Pumping}
      Except on E: exception do
      begin
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
    if (HlpVar>0) then AdjustScreen;
end;{TMainForm.EditPumpingChange}
{-------------------------------}



procedure TMainForm.KrHelpButton_Click(Sender: TObject);
{------------------------------------------------------}
begin
  inherited;
  HelpForm.Show;
end; {TMainForm.KrHelpButton_Click}
{---------------------------------}



procedure TMainForm.InputSymbols_ButtonClick(Sender: TObject);
{------------------------------------------------------------}
begin
  inherited;
  InputSymbolsForm.Show;
end; {TMainForm.InputSymbols_ButtonClick}
{---------------------------------------}



procedure TMainForm.MakeStrings;
{------------------------------}
var i,j,k : byte;
begin
  with DataMod do
  begin
    Edit1_1.Text := FloatToStr(Area);
    Combo2.ItemIndex := Ns-1;
    Combo3.ItemIndex := Kd;
    Combo4.ItemIndex := Kf;
    Combo5.ItemIndex := Kr;
    Combo6.ItemIndex := Kw;
    Edit2_1.Text := IntToStr(Ny);
    Edit2_3.Text := FloatToStr(SCRAM);
    Edit2_4.Text := FloatToStr(SCRBM);
    ComboKy.ItemIndex := Ky;
    for j:=1 to 4 do
    begin
      for k:=1 to Ns do
      begin
        Label4A[j,k].Enabled := true;
        Edit4A[j,k].Enabled := true;
      end;
      if Ns<4 then for k:=DataMod.Ns+1 to 4 do
      begin
        Label4A[j,k].Enabled := false;
        Edit4A[j,k].Enabled := false;
        Edit4A[j,k].Text := '-1';
      end;
    end; {for j:=1 to 4 do}
    for k:=1 to Ns do
        Edit4A[1,k].Text := FloatToStr(Ts[k]);
    for j:=4 to 15 do if j<>11 then
    begin
      for k:=1 to Ns do
      begin
        i:=1;
        while i<2*Ns+1 do
        begin
          Label8A[j,i].Enabled := true;
          Edit8A[j,i].Enabled := true;
          Label8A[j,i+1].Enabled := true;
          Edit8A[j,i+1].Enabled := true;
          i:=i+2;
        end;
(*
        while i>=2*Ns+1 do
        begin
          Label8A[j,i].Enabled := false;
          Edit8A[j,i].Enabled := false;
          Label8A[j,i+1].Enabled := false;
          Edit8A[j,i+1].Enabled := false;
          i:=i+2;
        end;
*)
      end;
      if Ns<4 then for k:=Ns+1 to 4 do
      begin
        i:=2*Ns+1;
        while i<9 do
        begin
          Label8A[j,i].Enabled := false;
          Edit8A[j,i].Enabled := false;
          Edit8A[j,i].Text := '-1';
          Label8A[j,i+1].Enabled := false;
          Edit8A[j,i+1].Enabled := false;
          Edit8A[j,i+1].Text := '-1';
          i:=i+2;
        end;
      end; {if Ns<4 then for k:=Ns+1 to 4 do}
    end; {for j:=4 to 15 do if j<>11 then}
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[4,k].Text := FloatToStr(A[j]);
      if A[j]=0 then
      begin
        Edit8A[5,k].Enabled:=false;
        Label8A[5,k].Enabled:=false;
        Edit8A[10,k].Enabled:=false;
        Label8A[10,k].Enabled:=false;
        Edit8A[14,k].Enabled:=false;
        Label8A[14,k].Enabled:=false;
      end;
      Edit8A[4,k+1].Text := FloatToStr(B[j]);
      if B[j]=0 then
      begin
        Edit8A[5,k].Enabled:=false;
        Label8A[5,k].Enabled:=false;
        Edit8A[10,k].Enabled:=false;
        Label8A[10,k].Enabled:=false;
        Edit8A[14,k].Enabled:=false;
        Label8A[14,k].Enabled:=false;
      end;
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[5,k].Text := FloatToStr(RcA[j]);
      Edit8A[5,k+1].Text := FloatToStr(RcB[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[6,k].Text := FloatToStr(Lc[j]);
      Edit8A[6,k+1].Text := FloatToStr(Io[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[7,k].Text := FloatToStr(IaA[j]);
      Edit8A[7,k+1].Text := FloatToStr(EpA[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[8,k].Text := FloatToStr(IaB[j]);
      Edit8A[8,k+1].Text := FloatToStr(EpB[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[9,k].Text := FloatToStr(Pp[j]);
      Edit8A[9,k+1].Text := FloatToStr(EpU[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[10,k].Text := FloatToStr(FsA[j]);
      Edit8A[10,k+1].Text := FloatToStr(FsB[j]);
      k:=k+2;
    end;
    for k:=1 to Ns do
      Edit4A[2,k].Text := FloatToStr(FsU[k]);
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[12,k].Text := FloatToStr(Gi[j]);
      Edit8A[12,k+1].Text := FloatToStr(Go[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[13,k].Text := FloatToStr(SiU[j]);
      Edit8A[13,k+1].Text := FloatToStr(SoU[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[14,k].Text := FloatToStr(SoA[j]);
      Edit8A[14,k+1].Text := FloatToStr(SoB[j]);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Edit8A[15,k].Text := FloatToStr(Gw[j]);
      Edit8A[15,k+1].Text := FloatToStr(Fw[j]);
      if Gw[j]<0.001 then
      begin
        Label8a[15,k+1].Enabled := false;
        Edit8a[15,k+1].Enabled := false;
        Edit8a[15,k+1].Text := '-1';
      end else
      begin
        Label8a[15,k+1].Enabled := true;
        Edit8a[15,k+1].Enabled := true;
//        Edit8a[15,k+1].Text := '-1';
      end;
      k:=k+2;
    end; {while k<2*Ns+1 do}
    Edit16_1.Text := FloatToStr(Dr);
    Edit16_2.Text := FloatToStr(Ptr);
    Edit16_3.Text := FloatToStr(Dx);
    Edit16_4.Text := FloatToStr(Ptx);
    Edit16_5.Text := FloatToStr(Dq);
    Edit16_6.Text := FloatToStr(Ptq);
    Edit17_1.Text := FloatToStr(Per);
    Edit17_2.Text := FloatToStr(Flr);
    Edit17_3.Text := FloatToStr(Pex);
    Edit17_4.Text := FloatToStr(Flx);
    Edit17_5.Text := FloatToStr(Peq);
    Edit17_6.Text := FloatToStr(Flq);
    Edit18_1.Text := FloatToStr(SCtr);
    Edit18_2.Text := FloatToStr(SCaq);
    Edit18_3.Text := FloatToStr(Zic);
    Edit18_4.Text := FloatToStr(Zigw);
    Edit18_5.Text := FloatToStr(Zrain);
    Edit19_1.Text := FloatToStr(CA0);
    Edit19_2.Text := FloatToStr(CB0);
    Edit19_3.Text := FloatToStr(CU0);
    Edit19_4.Text := FloatToStr(DWT);
    Edit19_5.Text := FloatToStr(CDW);
    if Kd=1 then
    begin
      Edit20_1.Text := FloatToStr(Dd);
      Edit20_2.Text := FloatToStr(QH1);
      Edit20_3.Text := FloatToStr(QH2);
      for k:=1 to Ns do
      begin
        Edit4A[3,k].Text := FloatToStr(Gu[k]);
        Label4A[3,k].Enabled := true;
        Edit4A[3,k].Enabled := true;
      end;
      Edit21_1.Text := FloatToStr(SCtrA);
      Edit21_2.Text := FloatToStr(SCtrB);
      for k:=1 to Ns do
      begin
          Edit4A[4,k].Text := FloatToStr(Frd[k]);
          Label4A[4,k].Enabled := true;
          Edit4A[4,k].Enabled := true;
      end;
      if Ns<4 then for k:=Ns+1 to 4 do
      begin
        Label4A[3,k].Enabled := false;
        Edit4A[3,k].Enabled := false;
        Edit4A[3,k].Text := '-1';
        Label4A[4,k].Enabled := false;
        Edit4A[4,k].Enabled := false;
        Edit4A[4,k].Text := '-1';
      end;
    end  {Kd=1}
    else {Kd=0}
    for k:=1 to 4 do
    begin
      Label4A[3,k].Enabled := false;
      Edit4A[3,k].Enabled := false;
      Edit4A[3,k].Text := '-1';
      Label4A[4,k].Enabled := false;
      Edit4A[4,k].Enabled := false;
      Edit4A[4,k].Text := '-1';
    end;
  end; {with DataMod do}
end; {TMainForm.MakeStrings}
{--------------------------}



procedure TMainForm.AdjustScreen;
{-------------------------------}
var k : byte;
    NoFallow : array[1..4] of boolean;
    Atot, Btot : real;
begin

  if not DataMod.AnnualCalc then
  begin
    Combo2.Enabled := true;
    Label1_2.Enabled := true;
    Label16_1.Enabled := true;
    Edit16_1.Enabled := true;
    Label16_2.Enabled := true;
    Edit16_2.Enabled := true;
    Label16_3.Enabled := true;
    Edit16_3.Enabled := true;
    Label16_4.Enabled := true;
    Edit16_4.Enabled := true;
    Label16_5.Enabled := true;
    Edit16_5.Enabled := true;
    Label16_6.Enabled := true;
    Edit16_6.Enabled := true;
    Edit18_1.Enabled := true;
    Label18_1.Enabled := true;
    Edit18_2.Enabled := true;
    Label18_2.Enabled := true;
    Edit19_1.Enabled := true;
    Label19_1.Enabled := true;
    Edit19_2.Enabled := true;
    Label19_2.Enabled := true;
    Edit19_3.Enabled := true;
    Label19_3.Enabled :=true;
    Edit19_4.Enabled := true;
    Label19_4.Enabled :=true;
    Edit21_1.Enabled := true;
    Label21_1.Enabled :=true;
    Edit21_2.Enabled := true;
    Label21_2.Enabled :=true;
  end; {if DataMod.AnnualCalc then else}

  if Combo3.ItemIndex<1 then                 {no drainage system}
  begin
     Label18_1.Enabled := true;
     Edit18_1.Enabled := true;
     Label20_1.Enabled := false;
     Edit20_1.Enabled := false;
     Label20_2.Enabled := false;
     Edit20_2.Enabled := false;
     Label20_3.Enabled := false;
     Edit20_3.Enabled := false;
     Label21_1.Enabled := false;
     Edit21_1.Enabled := false;
     Label21_2.Enabled := false;
     Edit21_2.Enabled := false;
     Edit20_1.Text := '0';
     Edit20_2.Text := '0';
     Edit20_3.Text := '0';
     Edit21_1.Text := '0';
     Edit21_2.Text := '0';
     for k:=1 to DataMod.Ns do
     begin
       Label4A[3,k].Enabled := false;
       Edit4A[3,k].Enabled := false;
       Label4A[4,k].Enabled := false;
       Edit4A[4,k].Enabled := false;
       Edit4A[3,k].Text := '0';
       Edit4A[4,k].Text := '0';
     end;
  end else                                         {drainage system present}
  begin
     Label18_1.Enabled := false;
     Edit18_1.Enabled := false;
     Label20_1.Enabled := true;
     Edit20_1.Enabled := true;
     Label20_2.Enabled := true;
     Edit20_2.Enabled := true;
     Label20_3.Enabled := true;
     Edit20_3.Enabled := true;
     Label21_1.Enabled := true;
     Edit21_1.Enabled := true;
     Label21_2.Enabled := true;
     Edit21_2.Enabled := true;
     for k:=1 to DataMod.Ns do
     begin
       Label4A[3,k].Enabled := true;
       Edit4A[3,k].Enabled := true;
       Label4A[4,k].Enabled := true;
       Edit4A[4,k].Enabled := true;
     end;
  end;

  ATot:=0;
  BTot:=0;
  for k:=1 to DataMod.Ns do NoFallow[k] := false;
  k:=1;
  while k<2*DataMod.Ns+1 do with DataMod do
  begin
    A[1+(k-1) div 2] := StringToFloat(Edit8A[4,k].Text);
    B[1+(k-1) div 2] := StringToFloat(Edit8A[4,k+1].Text);
    ATot:=Atot+A[1+(k-1) div 2];
    BTot:=Btot+B[1+(k-1) div 2];
    if StringToFloat(Edit8A[4,k].Text)<0.001 then               {area A = 0}
    begin
      Label8A[5,k].Enabled := false;
      Label8A[7,k].Enabled := false;
      Label8A[7,k+1].Enabled := false;
      Label8A[10,k].Enabled := false;
      Label8A[14,k].Enabled := false;
      Edit8A[5,k].Enabled := false;
      Edit8A[7,k].Enabled := false;
      Edit8A[7,k+1].Enabled := false;
      Edit8A[10,k].Enabled := false;
      Edit8A[14,k].Enabled := false;
    end;

    if StringToFloat(Edit8A[4,k+1].Text)<0.001 then             {area B = 0}
    begin
      Label8A[5,k+1].Enabled := false;
      Label8A[8,k].Enabled := false;
      Label8A[8,k+1].Enabled := false;
      Label8A[10,k+1].Enabled := false;
      Label8A[14,k+1].Enabled := false;
      Edit8A[5,k+1].Enabled := false;
      Edit8A[8,k].Enabled := false;
      Edit8A[8,k+1].Enabled := false;
      Edit8A[10,k+1].Enabled := false;
      Edit8A[14,k+1].Enabled := false;
    end;

    if StringToFloat(Edit8A[4,k].Text)>=0.001 then              {area A > 0}
    begin
      Label8A[5,k].Enabled := true;
      Label8A[7,k].Enabled := true;
      Label8A[7,k+1].Enabled := true;
      Label8A[10,k].Enabled := true;
      Label8A[14,k].Enabled := true;
      Edit8A[5,k].Enabled := true;
      Edit8A[7,k].Enabled := true;
      Edit8A[7,k+1].Enabled := true;
      Edit8A[10,k].Enabled := true;
      Edit8A[14,k].Enabled := true;
    end;

    if StringToFloat(Edit8A[4,k+1].Text)>=0.001 then             {area B > 0}
    begin
      Label8A[5,k+1].Enabled := true;
      Label8A[8,k].Enabled := true;
      Label8A[8,k+1].Enabled := true;
      Label8A[10,k+1].Enabled := true;
      Label8A[14,k+1].Enabled := true;
      Edit8A[5,k+1].Enabled := true;
      Edit8A[8,k].Enabled := true;
      Edit8A[8,k+1].Enabled := true;
      Edit8A[10,k+1].Enabled := true;
      Edit8A[14,k+1].Enabled := true;
    end;

    if (DataMod.Kf=0) and                                 {No farmers' response}
       ((A[1+(k-1) div 2] + B[1+(k-1) div 2])>0.999) then     {area U = 0}
    begin
      NoFallow[1+(k-1) div 2] := true;
      Label8A[9,k+1].Enabled := false;
      Label8A[13,k].Enabled := false;
      Label8A[13,k+1].Enabled := false;
      Edit8A[9,k+1].Enabled := false;
      Edit8A[13,k].Enabled := false;
      Edit8A[13,k+1].Enabled := false;
    end;

    if (DataMod.Kf=1) or                                    {Farmers' response}
       ((A[1+(k-1) div 2] + B[1+(k-1) div 2])<=0.999) then     {area U > 0}
    begin
      NoFallow[1+(k-1) div 2] := false;
      Label8A[9,k+1].Enabled := true;
      Label8A[13,k].Enabled := true;
      Label8A[13,k+1].Enabled := true;
      Edit8A[9,k+1].Enabled := true;
      Edit8A[13,k].Enabled := true;
      Edit8A[13,k+1].Enabled := true;
    end;

    if StringToFloat(Edit8A[15,k].Text)<0.001 then      {no pumping from wells}
    begin
      Label8A[15,k+1].Enabled := false;                  {Fw not applicable}
      Edit8A[15,k+1].Enabled := false;
    end else
    begin
      Label8A[15,k+1].Enabled := true;                       {Fw applicable}
      Edit8A[15,k+1].Enabled := true;
    end;

    k:=k+2;

  end; {while k<2*DataMod.Ns+1 do}

  if (DataMod.Kf=1) and ((Atot>0.001) or (Btot>0.001)) then
  begin
    Edit2_3.Visible:=true;
    Label2_3.Visible:=true;
    Edit2_4.Visible:=true;
    Label2_4.Visible:=true;
  end else
  begin
    Edit2_3.Visible:=false;
    Label2_3.Visible:=false;
    Edit2_4.Visible:=false;
    Label2_4.Visible:=false;
  end;

  for k:=1 to DataMod.Ns do if NoFallow[k] then
  begin
      Label4A[2,k].Enabled := false;                      {FsU not applicable}
      Edit4A[2,k].Enabled := false;
  end;
  for k:=1 to DataMod.Ns do if not NoFallow[k] then
  begin
      Label4A[2,k].Enabled := true;                           {FsU applicable}
      Edit4A[2,k].Enabled := true;
  end;
  if StringToFloat(Edit8A[4,1].Text)<0.001 then               {area A =0}
  begin
    Label19_1.Enabled := false;                            {CA0 not applicable}
    Edit19_1.Enabled := false;
  end;
  if StringToFloat(Edit8A[4,2].Text)<0.001 then               {area B =0}
  begin
    Label19_2.Enabled := false;                            {CB0 not applicable}
    Edit19_2.Enabled := false;
  end;
  if StringToFloat(Edit8A[4,1].Text)>=0.001 then             {area A =0}
  begin
    Label19_1.Enabled := true;                              {CA0 applicable}
    Edit19_1.Enabled := true;
  end;
  if StringToFloat(Edit8A[4,2].Text)>=0.001 then             {area B =0}
  begin
    Label19_2.Enabled := true;                              {CB0 applicable}
    Edit19_2.Enabled := true;
  end;
  if (DataMod.A[1]+DataMod.B[1]>=0.999) then
  begin
    Label19_3.Enabled := false;                            {CU0 not applicable}
    Edit19_3.Enabled := false;
  end else
  begin
    Label19_3.Enabled := true;                             {CU0 applicable}
    Edit19_3.Enabled := true;
  end;
  if DataMod.AnnualCalc then
  begin
    Combo2.Enabled := false;
    Label1_2.Enabled := false;
    Label16_1.Enabled := false;
    Edit16_1.Enabled := false;
    Label16_2.Enabled := false;
    Edit16_2.Enabled := false;
    Label16_3.Enabled := false;
    Edit16_3.Enabled := false;
    Label16_4.Enabled := false;
    Edit16_4.Enabled := false;
    Label16_5.Enabled := false;
    Edit16_5.Enabled := false;
    Label16_6.Enabled := false;
    Edit16_6.Enabled := false;
    Edit18_1.Enabled := false;
    Label18_1.Enabled := false;
    Edit18_2.Enabled := false;
    Label18_2.Enabled := false;
    Edit19_1.Enabled := false;
    Label19_1.Enabled := false;
    Edit19_2.Enabled := false;
    Label19_2.Enabled := false;
    Edit19_3.Enabled := false;
    Label19_3.Enabled := false;
    Edit19_4.Enabled := false;
    Label19_4.Enabled := false;
    Edit21_1.Enabled := false;
    Label21_1.Enabled := false;
    Edit21_2.Enabled := false;
    Label21_2.Enabled := false;
  end; {if DataMod.AnnualCalc then else}

end; {TMainForm.AdjustScreen;}
{----------------------------}



procedure TMainForm.MakeValues;
{-----------------------------}
var i,j,k : byte;
begin
  with DataMod do
  begin
    Area := StringToFloat(Edit1_1.Text);
    Ns := Combo2.ItemIndex+1;
    Kd := Combo3.ItemIndex;
    Kf := Combo4.ItemIndex;
    Kr := Combo5.ItemIndex;
    Kw := Combo6.ItemIndex;
    Ny := StrToInt(Edit2_1.Text);
    SCRAM := StrToInt(Edit2_3.Text);
    SCRBM := StrToInt(Edit2_4.Text);
    Ky := ComboKy.ItemIndex;
    for k:=1 to Ns do
        Ts[k]:=StringToFloat(Edit4A[1,k].Text);
    k := 1;
    for j:=1 to Ns do
    begin
      A[j]:= StringToFloat(Edit8A[4,k].Text);
      B[j]:= StringToFloat(Edit8A[4,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      RcA[j]:= StringToFloat(Edit8A[5,k].Text);
      RcB[j]:= StringToFloat(Edit8A[5,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Lc[j]:= StringToFloat(Edit8A[6,k].Text);
      Io[j]:= StringToFloat(Edit8A[6,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      IaA[j]:= StringToFloat(Edit8A[7,k].Text);
      EpA[j]:= StringToFloat(Edit8A[7,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      IaB[j]:= StringToFloat(Edit8A[8,k].Text);
      EpB[j]:= StringToFloat(Edit8A[8,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Pp[j]:= StringToFloat(Edit8A[9,k].Text);
      EpU[j]:= StringToFloat(Edit8A[9,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      FsA[j]:= StringToFloat(Edit8A[10,k].Text);
      FsB[j]:= StringToFloat(Edit8A[10,k+1].Text);
      k:=k+2;
    end;
    for k:=1 to Ns do
      FsU[k]:=StringToFloat(Edit4A[2,k].Text);
    k := 1;
    for j:=1 to Ns do
    begin
      Gi[j]:= StringToFloat(Edit8A[12,k].Text);
      Go[j]:= StringToFloat(Edit8A[12,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      SiU[j]:= StringToFloat(Edit8A[13,k].Text);
      SoU[j]:= StringToFloat(Edit8A[13,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      SoA[j]:= StringToFloat(Edit8A[14,k].Text);
      SoB[j]:= StringToFloat(Edit8A[14,k+1].Text);
      k:=k+2;
    end;
    k := 1;
    for j:=1 to Ns do
    begin
      Gw[j]:= StringToFloat(Edit8A[15,k].Text);
      Fw[j]:= StringToFloat(Edit8A[15,k+1].Text);
      k:=k+2;
    end; {while k<2*Ns+1 do}
    Dr := StringToFloat(Edit16_1.Text);
    Ptr := StringToFloat(Edit16_2.Text);
    Dx := StringToFloat(Edit16_3.Text);
    Ptx := StringToFloat(Edit16_4.Text);
    Dq := StringToFloat(Edit16_5.Text);
    Ptq := StringToFloat(Edit16_6.Text);
    Per := StringToFloat(Edit17_1.Text);
    Flr := StringToFloat(Edit17_2.Text);
    Pex := StringToFloat(Edit17_3.Text);
    Flx := StringToFloat(Edit17_4.Text);
    Peq := StringToFloat(Edit17_5.Text);
    Flq := StringToFloat(Edit17_6.Text);
    SCtr := StringToFloat(Edit18_1.Text);
    SCaq := StringToFloat(Edit18_2.Text);
    Zic := StringToFloat(Edit18_3.Text);
    Zigw := StringToFloat(Edit18_4.Text);
    Zrain := StringToFloat(Edit18_5.Text);
    CA0 := StringToFloat(Edit19_1.Text);
    CB0 := StringToFloat(Edit19_2.Text);
    CU0 := StringToFloat(Edit19_3.Text);
    DWT := StringToFloat(Edit19_4.Text);
    CDW := StringToFloat(Edit19_5.Text);
    if Kd=1 then
    begin
      Dd := StringToFloat(Edit20_1.Text);
      QH1 := StringToFloat(Edit20_2.Text);
      QH2 := StringToFloat(Edit20_3.Text);
      for k:=1 to Ns do
        Gu[k] := StringToFloat(Edit4A[3,k].Text);
      SCtrA := StringToFloat(Edit21_1.Text);
      SCtrB := StringToFloat(Edit21_2.Text);
      for k:=1 to Ns do
          Frd[k] := StringToFloat(Edit4A[4,k].Text);
    end  {Kd=1}
    else {Kd=0}
    for k:=1 to 4 do
    begin
      Label4A[3,k].Enabled := false;
      Edit4A[3,k].Enabled := false;
      Label4A[4,k].Enabled := false;
      Edit4A[4,k].Enabled := false;
    end;
  end; {with DataMod do}
end; {TMainForm.MakeValues}
{-------------------------}



procedure TMainForm.HideEdits;
{----------------------------}
begin
  Combo6.Visible:=false;
  Label1_6.Visible:=false;
  Edit2_3.Visible:=false;
  Label2_3.Visible:=false;
  Edit2_4.Visible:=false;
  Label2_4.Visible:=false;
end; {HideEdits}
{--------------}


procedure TMainForm.ShowEdits;
{----------------------------}
begin
  Combo6.Visible:=true;
  Label1_6.Visible:=true;
  Edit2_3.Visible:=true;
  Label2_3.Visible:=true;
  Edit2_4.Visible:=true;
  Label2_4.Visible:=true;
//  if Combo4.ItemIndex=1 then
//    ModernLabel.Visible:=false;
end; {ShowEdits}
{--------------}


function TMainForm.SetAndVerifySaveName;
{--------------------------------------}
begin Inherited;
      NoSave:=false;
      Result := false;
      if InputSave_Dialog.Execute then with DataMod do
      begin DataMod.FileName := InputSave_Dialog.Files.Strings[0];
        FileName := ChangeFileExt(FileName,'.INP');
        if FileExists(DataMod.FileName)
        then  Result :=
              Question('The file already exists, overwrite?')
        else  Result := true;
      end
      else NoSave:=true;
end; {TMainForm.VerifySaveName}
{-----------------------------}



function TMainForm.SetAndVerifyGroupName;
{---------------------------------------}
begin Inherited;
      NoSave:=false;
      Result := false;
      if GroupSave_Dialog.Execute then with DataMod do
      begin DataMod.FileName := GroupSave_Dialog.Files.Strings[0];
        FileName := ChangeFileExt(FileName,'.prn');
        if FileExists(DataMod.FileName)
        then  Result :=
              Question('The file already exists, overwrite?')
        else  Result := true;
      end
      else NoSave:=true;
end; {TMainForm.VerifySaveName}
{-----------------------------}



procedure TMainForm.DoCalculations;
{---------------------------------}
begin
  WaitMemo.Visible:=true;
  WaitMemo.Lines.Clear;
  WaitMemo.Lines.Add(' Calculating .....');
  CheckInputs;                                             {in unit ExtraUtils}
  DataMod.ReadErrorLines (RunTimeError,NrOfErrorLines);
  deletefile ('Error.lst');
  CalcDone := true;
  if RunTimeError then with DataMod do
  begin
    showmessage ('One or more errors in the input were detected.');
    OutputOpened:=false;
    GroupOpenButton.Visible:=false;
    CloseOutput_Button.Visible:=false;
    OutputSymbols_Button.Visible:=false;
    Output_Tabsheet.Show;
    WaitMemo.Visible:=false;
    FileName := ChangeFileExt(FileName,'.res');
    if fileexists (FileName) then deletefile (FileName);
    FileName := ChangeFileExt(FileName,'.frq');
    if fileexists (FileName) then deletefile (FileName);
    deletefile ('Warning.lst');
    exit;
  end;
  WTdepth:=false;
  Calculations;
  WarningForm.Visible:=false;
  RunTimeWarning:=false;
  if DataMod.Ky=0 then
  begin
    DataMod.ReadWarningLines (RunTimeWarning,NrOfWarningLines);;
    deletefile ('Warning.lst');
  end;
  GroupOpenButton.Visible:=true;
  CloseOutput_Button.Visible:=true;
  OutputSymbols_Button.Visible:=true;
end; {TMainForm.DoCalculations}
{-----------------------------}


procedure TMainForm.AnnualMessages;
{---------------------------------}
var OldYear, NewYear, InterFile, Nx : string;
    Result : boolean;
begin
  with DataMod do
  begin
    OldYear := IntToStr(YearNr);
    YearNr:=YearNr+1;
    NewYear := IntToStr(YearNr);
    InterFile := ChangeFileExt(OriginalName,'.res');
    if OldYear='1' then AnnualName:=FileName;
    AnnualName := ChangeFileExt(AnnualName,'.inp');
    Nx := IntToStr(Ny);
    if AnnualCalc and (YearNr<Ny+1) then
    begin
       Showmessage ('By setting the yearly calculation index Ky equal'+
       ' to 1 you have requested SaltMod calculations using the input'+
       ' file  '+AnnualName+'  for a time series of  '+Nx+'  years with the'+
       ' option to introduce annual input changes.  The end of the'+
       ' intermediate annual calculations of year  '+OldYear+ '  is'+
       ' reached. The intermediate results can be seen in output file  '
         +InterFile);
       Result := Question ('Do you wish to continue with the next'+
       ' year Nr '+NewYear);
       if Result then
       begin
         Showmessage ('Go to the input menu to continue. It is not'+
         ' necessary to adjust the initial values of soil salinity'+
         ' and water level, this is done automatically. To keep'+
         ' record if input changes, the input file may be saved' +
         ' in the same folder under a different (sequential) name' +
         ' at each annual run.');
         AdjustScreen;
       end else
       begin
         Showmessage ('The calculations for the time series are'+
         ' discontinued. Yet the intermediate results can be seen'+
         ' in  '+InterFile);
         YI:=0;
         EndOfAnnual := true;
         closefile (WarnFile);
         DataMod.ReadWarningLines (RunTimeWarning,NrOfWarningLines);;
         deletefile ('Warning.lst');
         AnnualCalc := false;
         AdjustScreen;
       end; {if Result}
    end; {if AnnualCalc and YearNr<Ny+1}
    if AnnualCalc and (YearNr=Ny+1) then
    begin
      Showmessage ('The end of the time series is reached. The results'+
      ' can be seen in  '+InterFile);
      YI:=0;
      EndOfAnnual := true;
      closefile (WarnFile);
      DataMod.ReadWarningLines (RunTimeWarning,NrOfWarningLines);;
      deletefile ('Warning.lst');
      AnnualCalc := false;
      AdjustScreen;
    end;
  end; {with DataMod do}
end; {TMainForm.AnnualMessages}
{-----------------------------}


{See also FileSave_Execute in Group MenuBar Buttons}


{******************************************************************************
 End of Input Tabsheet, start of Figure TabSheet
 ******************************************************************************}


procedure TMainForm.Figure_TabSheetShow(Sender: TObject);
begin Inherited;
    StatusText ('The figure gives explanations of symbols used in the' +
                ' input tabsheet');
end;{TMainForm.Figure_TabSheetShow}


procedure TMainForm.FigureButtonClick(Sender: TObject);
begin
  inherited;
  InputSymbolsForm.Show;
end;


{******************************************************************************
 End of Figure Tabsheet, start of Output TabSheet
 ******************************************************************************}


procedure TMainForm.Output_TabSheetShow(Sender: TObject);
{-------------------------------------------------------}
var k : integer;
    ReadingOK : boolean;
begin Inherited;
      InputSave.Enabled := false;
      StatusText ('Click "Output groups" or "Group file" to see graphs.'+
                  ' Alternatively click "Output file" to open an output file' +
                  ' to make graphs.');
      GroupOpened := false;
      Group_Button.Visible := true;
      if not OutputOpened then
      begin
        Group_Button.Visible := false;
        SaveGroupButton.Visible := false;
        ViewGraph_Button.Visible := false;
        CloseOutput_Button.Visible:=false;
        OutputSymbols_Button.Visible:=false;
        if not RunTimeError then
        begin
          Output_Memo.Visible:= false;
          SaltImage1.Visible := true;
        end;
      end;
      if CalcDone then with DataMod do
      begin
        FirstYear:=true;
        FileName:=ChangeFileExt (OriginalName,'.res');
        if RunTimeError then
        begin
          deletefile (FileName);
          Output_Memo.Visible:=false;
          Output_Memo.Lines.Clear;
          for k:=0 to NrOfErrorLines-1 do Output_Memo.Lines.Add(ErrorLines[k]);
          Output_Memo.Lines.Add('');
          Output_Memo.Lines.Add (' CALCULATIONS COULD NOT BE DONE');
          Output_Memo.Lines.Add (' Please adjust the input.');
          Output_Memo.Visible:= true;
          setlength (ErrorLines,1);
        end else
        begin
          if RunTimeWarning then with DataMod do
          begin
            showmessage ('One or more runtime comments are given.');
            WarningForm.WarningMemo.Visible:=false;
            WarningForm.WarningMemo.Lines.Clear;
            WarningForm.WarningMemo.Lines.Add('');
            for k:=0 to NrOfWarningLines-1 do
                WarningForm.WarningMemo.Lines.Add(WarningLines[k]);
            WarningForm.WarningMemo.Lines.Add('');
            WarningForm.WarningMemo.Visible:=true;
            WarningForm.Visible:=true;
            RunTimeWarning:=false;
          end;
          if WTdepth then if DataMod.AnnualCalc and not DataMod.EndOfAnnual then
          begin
            showmessage ('The watertable reached the bottom of the aquifer.'+
                         ' The output can be partially seen, but the annual'+
                         ' calculations cannot be continued. Please adjust'+
                         ' the input and start the annual procedure again.');
          end;
          Output_Memo.Visible := false;
          chdir (OriginalDir);                          //nodig? necessary?
          ReadOutputLines(FileName,ReadingOK);
          if not ReadingOk then exit;
          Output_Memo.Lines.Clear;
          for k:=1 to DataMod.NrOfLines do
            Output_Memo.Lines.Add(FileLine[k-1]);
          Output_Memo.Visible := true;
          GroupOpenButton.Visible:=true;
          CloseOutput_Button.Visible:=true;
          OutputSymbols_Button.Visible:=true;
          SaltImage1.Visible := false;
          ViewGraph_Button.Visible := false;
          SaveGroupButton.Visible := false;
          OutputSymbols_Button.Visible:=true;
        end; {if RunTimeError then else}
      end; {if CalcDone then with DataMod do}
      CalcDone:=false;
end; {TMainForm.Output_TabSheetShow}
{----------------------------------}


{see also OutputOpen_Execute in Group MenuBar buttons, activated when
 clicking on the SeeOutput_Button}


procedure TMainForm.OutputSymbols_ButtonClick(Sender: TObject);
{-------------------------------------------------------------}
begin
  inherited;
  OutputSymbolsForm.Show;
end; {TMainForm.OutputSymbols_ButtonClick}
{----------------------------------------}



procedure TMainForm.Group_ButtonClick(Sender: TObject);
{-----------------------------------------------------}
begin
  inherited;
  SaveGroupButton.Visible := false;
  ViewGraph_Button.Visible := false;
  Panel1.Show;
end; {TMainForm.Group_ButtonClick}
{--------------------------------}



procedure TMainForm.Go_ButtonClick(Sender: TObject);
{--------------------------------------------------}
var ii, jj, k : integer;
    ReadingOK : boolean;
begin
  inherited;
  ViewGraph_Button.Enabled:=true;
  with DataMod do
  begin
    SaveGroupButton.Visible := true;
    ViewGraph_Button.Visible := true;
    ChangeFileExt(FileName,'.res');
    if RadioButton1.Checked then
    begin
       GroupMark := 'CrA';
       ReadOutputGroup('CrA');
       ShowOutputGroup('CrA');
    end else
    if RadioButton2.Checked then
    begin
       GroupMark := 'Cxf';
       ReadOutputGroup('Cxf');
       ShowOutputGroup('Cxf');
    end else
    if RadioButton3.Checked then
    begin
       GroupMark := 'Zs';
       ReadOutputGroup('Gd');
       ShowOutputGroup('Zs');
    end else
    if RadioButton4.Checked then
    begin
       GroupMark := 'Gd';
       ReadOutputGroup('Gd');
       ShowOutputGroup('Gd');
    end else
    if RadioButton5.Checked then
    begin
       GroupMark := 'Dw';
       ReadOutputGroup('Gd');
       for jj:=0 to DataMod.NrOfData-1 do
           DataMod.Variable[5,jj]:= -DataMod.Variable[5,jj];
       ShowOutputGroup('Dw');
    end else
    if RadioButton6.Checked then
    begin
       GroupMark := 'LrA';
       ReadOutputGroup('LrA');
       ShowOutputGroup('LrA');
    end else
    if RadioButton7.Checked then
    begin
       GroupMark := 'RrA';
       ReadOutputGroup('RrA');
       ShowOutputGroup('RrA');
    end else
    if RadioButton8.Checked then
    begin
       GroupMark := 'It';
       ReadOutputGroup('It');
       ShowOutputGroup('It');
    end else
    if RadioButton9.Checked then
    begin
       GroupMark := 'FfA';
       ReadOutputGroup('FfA');
       ShowOutputGroup('FfA');
       for ii:=1 to Datamod.NrOfitems do
         for jj:=0 to DataMod.NrOfData-1 do
             DataMod.Variable[ii,jj]:= 100*DataMod.Variable[ii,jj];
    end else
    if RadioButton10.Checked then
    begin
       GroupMark := 'EaU';
       ReadOutputGroup('FfA');
       ShowOutputGroup('EaU');
    end else
    if RadioButton11.Checked then
    begin
       GroupMark := 'A';
       ReadOutputGroup('A');
       ShowOutputGroup('A');
       for ii:=1 to Datamod.NrOfitems do
         for jj:=0 to DataMod.NrOfData-1 do
             DataMod.Variable[ii,jj]:= 100*DataMod.Variable[ii,jj];
    end else
    if Radiobutton12.checked then
    begin
       GroupMark := 'Kr';
       ReadOutputGroup('A');
       ShowOutputGroup('Kr');
    end else
    if RadioButton13.Checked then
    begin
      FileName:=ChangeFileExt(FileName,'.frq');
      ReadOutputLines (FileName,ReadingOK);
      if not ReadingOk then exit;
      Panel1.Hide;
      Output_Memo.Hide;
      ViewGraph_Button.Enabled:=false;
      Output_Memo.Lines.Clear;
      for k:=1 to DataMod.NrOfLines do
          Output_Memo.Lines.Add(FileLine[k-1]);
      Output_Memo.Show;
      FileName:=ChangeFileExt(FileName,'.res');
    end
    else
      Panel1.Hide;
  end; {with DataMod do}
  if not RadioButton13.Checked then GroupOpened:=true;
end; {TMainForm.Go_ButtonClick}
{-----------------------------}



procedure TMainForm.ShowOutputGroup (const GroupSign : string);
{-------------------------------------------------------------}
var i, k, SeasonNr,YearNumber : integer;
begin
  Panel1.Hide;
  Output_Memo.Hide;
  Output_Memo.Lines.Clear;
  with DataMod do
  begin
    for i:=1 to 7 do PosValues[i]:=false;
    for i:=1 to NrOfitems do for k:=0 to NrOfData-1 do
      if Variable[i,k]>0 then PosValues[i]:=true;
    if GroupSign='Dw' then PosValues[5]:=true;
    setlength(FileLine,3);
    if GroupSign='CrA' then
    begin
      FileLine[0] := ('"Soil salinities of the root zone'+
                      ' CrA (irr. A crops), CrB (irr. B crops)," ');
      FileLine[1] := ('"CrU (not irr.), Cr4 (full rotation)'+
                      ' and outside (C*) in dS/m, see symbols" ');
      FileLine[2] := (' Year Season    CrA       CrB       CrU       Cr4'+
                      '       C0*       C1*       C2*       C3*');
    end;
    if GroupSign='Cxf' then
    begin
      FileLine[0] := ('"Salinity of the trans. zone (Cxf, Cxa, Cxb),'+
                      ' aquifer (Cqf), (mixed) irrigation" ');
      FileLine[1] := ('"water (Ci), drainage (Cd) and well water (Cw)'+
                      ' EC in dS/m, see symbols list" ');
      FileLine[2] := (' Year Season    Cxf       Cxa       Cxb       Cqf'+
                      '       Ci        Cd        Cw');
    end;
    if GroupSign='Zs' then
    begin
      FileLine[0] := ('"Salt storage above the soil'+
                      ' surface (Zs) in m.dS/m per season" ');
      FileLine[1] := ('"only when the water table is above the'+
                      ' surface, see symbols list" ');
      FileLine[2] := (' Year Season    Zs');
    end;
    if GroupSign='Gd' then
    begin

      FileLine[0] := ('"Drain (Gd, Ga, Gb) and well (Gw) discharge'+
                      ' in m/season" ');
      FileLine[1] := ('"Ga and Gb are drainage flows above and below'+
                      ' drain level, see symbols list" ');
      FileLine[2] := (' Year Season    Gd        Ga        Gb        Gw ');
    end;
    if GroupSign='Dw' then
    begin
      FileLine[0] := ('"Depth of the water table Dw in m" ');
      FileLine[1] := ('"When the watertable is below soil surface'+
                      ' the depth is given as a negative value" ');
      FileLine[2] := (' Year Season     Dw');
    end;
    if GroupSign='LrA' then
    begin
      FileLine[0] := ('"Water percolating down to the'+
                      ' water table in A land (LrA), B land (RrB)," ');
      FileLine[1] := ('"unirrigated U land (LrU), and total area'+
                      ' average (Lr) in m/season, see symbols list" ');
      FileLine[2] := (' Year Season    LrA       LrB       LrU       Lr');
    end;
    if GroupSign='RrA' then
    begin
      FileLine[0] := ('"Capillary rise up from the'+
                      ' water table in A land (RrA), B land (RrB)," ');
      FileLine[1] := ('"unirrigated U land (RrU) and total area'+
                      ' average (Rr) in m/season, see symbols list" ');
      FileLine[2] := (' Year Season    RrA       RrB       RrU       Rr');
    end;
    if GroupSign='It' then
    begin
      FileLine[0] := ('"Amounts of irrigation water (m/season),'+
                      ' It = total, Is = net, Io = bypass," ');
      FileLine[1] := ('"IaA and IaB are field applications'+
                      ' to land under A and B crops, see symbols" ');
      FileLine[2] := (' Year Season     It        Is        Io '+
                      '      IaA       IaB');
    end;
    if GroupSign='FfA' then
    begin
      FileLine[0] := ('"Irrigation efficiency in A (FfA) and B land (FfB)'+
                      ' and total (Fft)" ');
      FileLine[1] := ('"sufficiency in A (JsA) and B land (JsB),'+
                      ' fractions, see symbols list" ');
      FileLine[2] := (' Year Season    FfA       FfB       Fft'+
                      '       JsA       JsB');
    end;
    if GroupSign='EaU' then
    begin
      FileLine[0] := ('"Actual evaporation from unirrigated land '+
                      ' EaU in m/season," ');
      FileLine[1] := ('"see symbols list" ');
      FileLine[2] := (' Year Season    EaU');
    end;
    if GroupSign='A' then
    begin
      FileLine[0] := ('"Area fraction of irrigated A land, B land, '+
                      ' un-irrigated land (U), and" ');
      FileLine[1] := ('"permanently fallow land (Uc),'+
                      ' see symbols list" ');
      FileLine[2] := (' Year Season     A         B         U'+
                      '        Uc');
    end;
    if GroupSign='Kr' then
    begin
      FileLine[0] := ('"Crop rotation index (Kr),'+
                      ' this may change when the Kf key for" ');
      FileLine[1] := ('"farmers responses is set to 1,'+
                      ' see symbols list" ');
      FileLine[2] := (' Year Season      Kr');
    end;
    YearNumber:=1;
    SeasonNr:=0;
    for k:=1 to DataMod.NrOfData do
    begin
      setlength(FileLine,k+3);
      SeasonNr:=SeasonNr+1;
      if SeasonNr>Ns then
      begin
        YearNumber:=YearNumber+1;
        SeasonNr:=1;
      end;
      if YearNumber<11 then
          FileLine[k+2]:=('  '+IntToStr(YearNumber-1)+'       '+
                          IntToStr(SeasonNr)+'   ')
      else
          FileLine[k+2]:=(' '+IntToStr(YearNumber-1)+'       '+
                          IntToStr(SeasonNr)+'   ');
      for i:= 1 to DataMod.NrOfitems do
      begin
        if GroupSign<>'Dw' then
        begin
          if (DataMod.Variable[i,k-1]<0) and PosValues[i] then
              MainStr[i]:='   -      ';
          if (DataMod.Variable[i,k-1]<0) and not PosValues[i] then
              MainStr[i]:='  n.a.    ';
          if (DataMod.Variable[i,k-1]>=0) and not PosValues[i] then
              if not (GroupSign='Kr') then MainStr[i]:='   -      ';
          if (GroupSign='Kr') or
             ((DataMod.Variable[i,k-1]>=0) and PosValues[i]) then
          begin
            MainStr[i]:=FloatToStr(DataMod.Variable[i,k-1]);
            if Length(MainStr[i])<10 then
               MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
            while length(MainStr[i])<11 do
            begin
              MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
              MainStr[i]:=ConCat(' ',DataMod.MainStr[i]);
            end;
            if length(MainStr[i])>11 then delete (MainStr[i],10,1);
            if length(MainStr[i])>10 then delete (MainStr[i],10,1);
          end;
        end;

        if GroupSign='Dw' then
        begin
          MainStr[i]:=FloatToStr(DataMod.Variable[i,k-1]);
          if Length(MainStr[i])<10 then
             MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
          while length(MainStr[i])<11 do
          begin
            MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
            MainStr[i]:=ConCat(' ',DataMod.MainStr[i]);
          end;
          if length(MainStr[i])>11 then delete (MainStr[i],10,1);
          if length(MainStr[i])>10 then delete (MainStr[i],10,1);
        end; {if GroupSign='Dw' then}

        if (GroupSign='CrA') or (GroupSign='Cxf') or
           (GroupSign='LrA') or (GroupSign='RrA') or
           (GroupSign='It') then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='Zs' then if i=6 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[6];
        if GroupSign='Gd' then if i<5 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='Dw' then if i=5 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[5];
        if GroupSign='FfA' then if i<6 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='A' then if i<5 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='EaU' then if i=6 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[6];
        if GroupSign='Kr' then if i=5 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[5];
      end; {for i:= 1 to DataMod.NrOfitems do}
    end; {for k:=1 to NrOfData do}
    GroupTitle:='"Data from: '+Filename+'"';
    Output_Memo.Lines.Add(GroupTitle);
    for k:=1 to NrOfData+3 do
        Output_Memo.Lines.Add(FileLine[k-1]);
    GrTitle1 := FileLine[0];
    GrTitle2 := FileLine[1];
    GrTitle3 := FileLine[2];
  end; {with DataMod do}
  Output_Memo.Show;
end; {TMainForm.ShowOutputGroup}
{------------------------------}


procedure TMainForm.GroupSave_Execute (Sender: TObject);
{------------------------------------------------------}
label 1;
var OutputFile : string;
    Count, k   : byte;
begin Inherited;
   Statustext ('Group data are saved as *.PRN files for spreadsheet use');
   OutputFile:=DataMod.FileName;
   with DataMod do
   begin
1:   if (SetAndVerifyGroupName) and not NoSave then
      begin
         if RadioButton13.Checked then
         begin
           WriteOutputLines (FileName);
         end else WriteOutputGroup (FileName);
      end else
      begin
        Showmessage ('The group data were not saved');
        exit;
      end;
      Count:=0;
      for k:=1 to length(DataMod.FileName) do
        if DataMod.FileName[k]='.' then Count:=Count+1;
      if Count>1 then
      begin
        Showmessage ('The number of dots (.) in the file name'+
                     ' should not be greater than 1. Please adjust.');
        DataMod.FileName:='';
        goto 1;
      end;
      ShowMessage ('The group data are saved in ' + FileName);
   end; {with DataMod do}
   DataMod.FileName:=OutputFile;
end; {TMainForm.GroupSave_Execute}
{--------------------------------}



procedure TMainForm.CloseOutput_ButtonClick(Sender: TObject);
{-----------------------------------------------------------}
begin
  inherited;
  DataMod.YearNr:=0;
  DataMod.EndOfAnnual:=false;
  Input_Tabsheet.Show;
end;{TMainForm.CloseOutput_ButtonClick}
{-------------------------------------}



procedure TMainForm.ViewGraph_ButtonClick(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  GroupOpened := true;
  SaltImage2.Visible := false;
  ShowGraphics;
  if not AllZero then Graphics_Tabsheet.Show;
  AllZero:=false;
end; {TMainForm.ViewGraphButtonClick}
{-----------------------------------}


{******************************************************************************
 End of Output tabsheet, start of Graphics Tabsheet
*******************************************************************************}


procedure TMainForm.Graphics_TabSheetShow(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  InputSave.Enabled := false;
  Statustext ('Graphics presentations of output data can be seen and saved.'+
              ' Use "Output file" to open an output file and make graphs.');
  if GroupOpened then
  begin
    SaltImage2.Visible := false;
    GraphOpened := true;
  end else
  begin
    GraphImage.Visible := false;
    SaveGraph_Button.Enabled := false;
    ShowSymbolsButton.Enabled := false;
    SaltImage2.Visible := true;
  end;
end; {TMainForm.Graphics_TabSheetShow}
{------------------------------------}


procedure TMainForm.ShowGraphics;
{--------------------------------}
var Count, ii, jj, kk, Score : integer;
    DumReal                  : real;
    NameStr, AuxFile         : string;
    ScalarY, DecimalY        : integer;
    MaximY, MinimY           : longint;
    HlpInt, NrOfObjects      : integer;
begin
  GraphSave.Enabled := true;
  AllZero:=false;
  if ((DataMod.GroupMark='Zs') or (DataMod.GroupMark='EaU')) and
  not PosValues[6] then
  begin
    AllZero:=true;
    Showmessage ('No data present. Graph is not made');
//    Output_Tabsheet.Show;
    exit;
  end;
  MaxMin;
  Scaling;
  Relative;
  With GraphImage.Canvas do with DataMod do
  begin
    Brush.Color := clWhite;
    FillRect(GraphImage.Canvas.ClipRect);
    Font.Style := [fsBold];
    Font.Color := clTeal;      {for the titles}
    if GroupMark<>'Dw' then
    begin
      Textout (120,15,GrTitle1);
      Textout (120,30,GrTitle2);
    end else
    begin
      Textout (120,10,GrTitle1);
      Textout (120,25,GrTitle2);
    end;
    Brush.Color := $00f5fffa;
    Font.Color := clMaroon;     {for the text}
    Pen.Color := clBlue;        {for the lines}

    MaximY:=0;
    MinimY:=1000000;
    ScalarY := 10;
    DecimalY := 1;
    if (GroupMark='CrA') or (GroupMark='Cxf') or
       (GroupMark='LrA') or (GroupMark='RrA') or
       (GroupMark='It') then
    begin
       Count:=0;
       for ii:=1 to NrOfitems do if PosValues[ii] then
       begin
         Count:=Count+1;
         if MaximY<MaxY[ii] then
         begin
           MaximY:=MaxY[ii];
           ScalarY:=ScaleY[ii];
           DecimalY:=DecimY[ii];
         end;
         if MinimY>MinY[ii] then
            MinimY:=MinY[ii];
       end;
       if Count=0 then
       begin
         AllZero:=true;
         Showmessage ('No data present. Graph is not made');
         Output_Tabsheet.Show;
         exit;
       end;
    end;

    if (GroupMark='FfA') or (GroupMark='A') then
    begin
      Count:=0;
      for ii:=1 to NrOfitems-1 do if PosValues[ii] then
          Count:=Count+1;
      AllZero:=false;
      if Count=0 then
      begin
        AllZero:=true;
        Showmessage ('No data present. Graph is not made');
//        Output_Tabsheet.Show;
        exit;
      end;
      MaximY:=120;
      MinimY:=0;
      ScalarY:=6;
    end;

    if (GroupMark='Zs') or (GroupMark='EaU') then
    begin
      MaximY:=MaxY[6];
      MinimY:=MinY[6];
      ScalarY:=ScaleY[6];
      DecimalY:=DecimY[6];
    end; {if (GroupMark='Zs') or (GroupMark='EaU') then}

    if (GroupMark='Gd') then
    begin
      Count:=0;
      for ii:=1 to 4 do if PosValues[ii] then
      begin
         Count:=Count+1;
         if MaximY<MaxY[ii] then
         begin
           MaximY:=MaxY[ii];
           ScalarY:=ScaleY[ii];
           DecimalY:=DecimY[ii];
         end;
         if MinimY>MinY[ii] then
            MinimY:=MinY[ii];
      end;
      AllZero:=false;
      if Count=0 then
      begin
        AllZero:=true;
         Showmessage ('No data present. Graph is not made');
//         Output_Tabsheet.Show;
        exit;
      end;
    end;{ if (GroupMark='Gd') or (GroupMark='A') then }

    if (GroupMark='Dw') or (GroupMark='Kr') then
    begin
      MaximY:=MaxY[5];
      MinimY:=MinY[5];
      ScalarY:=ScaleY[5];
      DecimalY:=DecimY[5];
    end; {if GroupMark='Dw' or (GroupMark='Kr') then}

    HlpInt:=0;
    if (GroupMark='FfA') or (GroupMark='A') then HlpInt:=1;
    for ii:=HlpInt to ScalarY do                         { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScalarY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScalarY)*LY));
      DumReal := ii/ScalarY*(MaximY-MinimY);
      NameStr := format('%' + IntToStr(2 + DecimalY) + '.' +
                 IntToStr(DecimalY) + 'f', [MaximY - DumReal]);
          {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      if ii<ScalarY then
         Textout ((posX1-TextWidth(NameStr)-6),
         (round(posY1+(ii/ScalarY)*LY)-round(1/2*TextHeight(NameStr))),
                                                            NameStr);
      if (GroupMark='Dw') and (ii=ScalarY) then
         Textout ((posX1-TextWidth(NameStr)-6),
         (round(posY1+(ii/ScalarY)*LY)-round(1/2*TextHeight(NameStr))),
                                                            NameStr);
    end; {for ii:=0 to ScalarY do}

      Count:=-1;                               {horizontal axis}
      TextOut(PosX1-5,PosY2+10,'0');
      TextOut(625,PosY2+25,'Year');
      for jj:= 0 to Ny-1 do
        for ii:=1 to Ns do
        begin
          Count:=Count+1;
          if ii=Ns then
          begin
            TextOut (RelXdata[Count]-5,PosY2+10,IntToStr(jj+1));
            Moveto (RelXdata[Count], PosY2);
            Lineto (RelXdata[Count], PosY2+6);
          end else
          begin
            Moveto (RelXdata[Count],PosY2);
            Lineto (RelXdata[Count],PosY2+4);
          end;
        end; {for jj:= 0 to Ny do for ii:=1 to Ns do}

    if (GroupMark='CrA') or (GroupMark='Cxf') then
    begin
      Score:=0;                                   {plotting of lines}
      if GroupMark='CrA' then
      TextOut (PosX1+10,PosY1-15,'Soil salinity, EC in dS/m');
      if GroupMark='Cxf' then
      TextOut (PosX1+10,PosY1-15,'Other salinities, EC in dS/m');
      Font.Style := [];
      if GroupMark='CrA' then
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the value of rotation key Kr')
      else
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the value of drainage key Kd');

      Font.Style:= [fsBold];
      Pen.Width := 2;
      for ii:=1 to NrOfitems do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clBlue;
          Font.Color := clBlue;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrA')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrA*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrA*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxf')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxf*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxf*100');
          end;
        end;
        if ii=2 then
        begin
          Pen.Color := clGreen;
          Font.Color:= clGreen;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrB')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrB*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrB*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CxA')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CxA*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CxA*100');
          end;
        end;
        if ii=3 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrU')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrU*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrU*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxb')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxb*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxb*100');
          end;
        end;
        if ii=4 then
        begin
          Pen.Color := clLime;
          Font.Color:= clLime;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cr4')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cr4*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cr4*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cqf')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cqf*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cqf*100');
          end;
        end;
        if ii=5 then
        begin
          Pen.Color := clSilver;
          Font.Color:= clSilver;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C0*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C0*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C0*100');
          end;
          if GroupMark='Cxf' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Ci')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Ci*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Ci*100');
        end;
        if ii=6 then
        begin
          Pen.Color := clFuchsia;
          Font.Color:= clFuchsia;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C1*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C1*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C1*100');
          end;
          if GroupMark='Cxf' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cd')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cd*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cd*100');
        end;
        if ii=7 then
        begin
          Pen.Color := $008AD5FD;
          Font.Color:= $008AD5FD;
          if GroupMark='CrA' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C2*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C2*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C2*100');
          if GroupMark='Cxf' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cw')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cw*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cw*100');
          end;
        if ii=8 then
        begin
          Pen.Color := clMaroon;
          Font.Color:= clMaroon;
          if GroupMark='CrA' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C3*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C3*10')
             else if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C3*100');
        end;

        if (GroupMark<>'Cxf') or ((GroupMark='Cxf') and (ii<5)) then
        for jj:=0 to Ny-1 do
            for kk:=1 to Ns do
            begin
              Count:=Count+1;
              if (Count>1) and (Count<Ns*Ny) then if RelYdata[ii,Count]=370 then
              begin
                 RelYdata[ii,Count] := RelYdata[ii,Count-1];
                 Pen.Color:=clsilver;
                 pen.Width:=1;
                 Pen.Style:=psdot;
                 if Count<Ns*Ny-2*Ns then
                 if (RelYdata[ii,Count+Ns]=RelYData[ii,Count+2*Ns]) then
                     Pen.Color:=clwhite;
                 RelYdata[ii,Count] := RelYdata[ii,count-1];
              end;
              if (Count>1) and (Count<Ns*Ny) then
              if (RelYdata[ii,Count-1]=370) and (RelYData[ii,Count]<370) then
              begin
                 Pen.Color:=clWhite;
                 RelYdata[ii,Count-1] := RelYdata[ii,count];
              end;
              if (Count>1) and (Count<Ns*Ny) then
              begin
                Moveto (RelXdata[Count-1],RelYdata[ii,Count-1]);
                Lineto (RelXdata[Count],RelYdata[ii,Count]);
              end;
              Pen.Style:=psSolid;
              Pen.Width:=2;
              if ii=1 then Pen.Color := clBlue;
              if ii=2 then Pen.Color := clGreen;
              if ii=3 then Pen.Color := clRed;
              if ii=4 then Pen.Color := clLime;
              if ii=5 then Pen.Color := clSilver;
              if ii=6 then Pen.Color := clFuchsia;
              if ii=7 then Pen.Color := $008AD5FD;
              if ii=8 then Pen.Color := clMaroon;
            end;
        if ((GroupMark='Cxf') and (ii>4)) then
        for jj:=0 to Ny-1 do
            for kk:=1 to Ns do
            begin
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1],RelYData[ii,Count-1]);
                Lineto (RelXdata[Count-1],RelYdata[ii,Count]);
                Moveto(RelXdata[Count-1],RelYdata[ii,Count]);
                Lineto (RelXdata[Count],RelYdata[ii,Count]);
              end;
            end;
      end; {for ii:=1 to NrOfitems do if PosValues[ii] then}
      Pen.Width := 1;
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end; {if (GroupMark='CrA') or (GroupMark='Cxf') then}

    if (GroupMark='Zs') then
    begin
      Pen.Color := clNavy;
      Font.Color:= clNavy;
      Count:=0;
      TextOut (PosX1+10,PosY1-15,'Salt storage Zs in m.dS/m');
      if FactorY[6]=1 then
         TextOut (PosX1+15,PosY1,'Zs')
      else
      if FactorY[6]=10 then
         TextOut (PosX1+15,PosY1,'Zs*10')
      else
      if FactorY[6]=100 then
         TextOut (PosX1+15,PosY1,'Zs*100');
      for jj:=0 to Ny-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if (Count<NrOfData) then
            begin
              Moveto (RelXdata[Count-1],RelYdata[6,Count-1]);
              Lineto (RelXdata[Count],RelYdata[6,Count]);
            end;
          end;
      Font.Color := clMaroon;     {for the text}
    end;{if GroupMark='Zs' then}

    if (GroupMark='Gd') or (GroupMark='A') then
    begin
      if (GroupMark='Gd') then
         TextOut (PosX1+10,PosY1-15,'Drain/well discharge (m/season)');
      if (GroupMark='A') then
         TextOut (PosX1+10,PosY1-15,'Area fractions (%)');

      Font.Style := [];
      TextOut (293,45,'Only applicable values are shown depending'+
                      ' on the parameter values employed');
      Font.Style:= [fsBold];
      Score:=0;
      for ii:=1 to 4 do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clBlue;
          Font.Color := clBlue;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Gd')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Gd*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'A');
        end;
        if ii=2 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Ga')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Ga*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'B');
        end;
        if ii=3 then
        begin
          Pen.Color := clGreen;
          Font.Color:= clGreen;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Gb')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Gb*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'U');
       end;
        if ii=4 then
        begin
          Pen.Color := $008AD5FD;
          Font.Color:= $008AD5FD;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Gw')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Gw*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'Uc');
        end;
        for jj:=0 to Ny-1 do
            for kk:=1 to Ns do
            begin
              HlpInt:=ii-1;
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1]+HlpInt,RelYData[ii,Count-1]-2*HlpInt);
                Lineto (RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Moveto(RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Lineto (RelXdata[Count]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
              end;
            end;
      end;{for ii:=1 to 4 do if PosValues[ii] then}
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end;{ if (GroupMark='Gd') or (GroupMark='A') then }

    if (GroupMark='Dw') or (GroupMark='Kr') then
    begin
      Pen.Color := clNavy;
      Font.Color:= clNavy;
      if (GroupMark='Dw') then
          TextOut (PosX1+10,PosY1-25,'')
      else
          TextOut (PosX1+10,PosY1-15,'Crop rotation index (-)');
      if (GroupMark='Dw') then
      begin
         if FactorY[5]=1 then
            TextOut (PosX1+10,PosY1-20,'Dw')
         else
         begin
           NameStr:=IntToStr(FactorY[5]);
           TextOut (PosX1+10,PosY1-20,'Dw*'+NameStr);
         end;
      end else
         TextOut (PosX1+15,PosY1,'Kr');

      Count:=0;
      for jj:=0 to Ny-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if kk=1 then Brush.Color := clOlive;
            if kk=2 then Brush.Color := clSilver;
            if kk=3 then Brush.Color := clYellow;
            if kk=4 then Brush.Color := clRed;
            if (Count<DataMod.NrOfData) then
            begin
              HlpInt:=PosY2-round(LY*(0-MinY[5])/(MaxY[5]-MinY[5]));
              if Variable[5,Count]<=0 then
                 Fillrect (Rect(RelXdata[Count-1],HlpInt,
                           RelXdata[Count],RelYdata[5,Count]))
              else
                 Fillrect (Rect(RelXdata[Count-1],RelYdata[5,Count],
                           RelXdata[Count],HlpInt));
            end;
          end;
      Brush.Color := $00f5fffa;
      Font.Color := clMaroon;     {for the text}
      Pen.Color := clBlue;
    end;{if (GroupMark='Dw')or (GroupMark='Kr') then }

    if (GroupMark='LrA') or (GroupMark='RrA') then
    begin
      Score:=0;                                   {plotting of lines}
      if GroupMark='LrA' then
      TextOut (PosX1+10,PosY1-15,'Pecolation in m/season');
      if GroupMark='RrA' then
      TextOut (PosX1+10,PosY1-15,'Capillary rise in m/season');
      Font.Style := [];
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the parameter values given');
      Font.Style:= [fsBold];
      for ii:=1 to NrOfitems do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clBlue;
          Font.Color := clBlue;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrA*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrA*'+NameStr);
            end;
          end;
        end;
        if ii=2 then
        begin
          Pen.Color := clGreen;
          Font.Color:= clGreen;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrB*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrB*'+NameStr);
            end;
          end;
        end;
        if ii=3 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrU')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrU*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrU')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrU*'+NameStr);
            end;
          end;
        end;
        if ii=4 then
        begin
          Pen.Color := clLime;
          Font.Color:= clLime;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrAve')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrAve*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrAve')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrAve*'+NameStr);
            end;
          end;
        end;
        for jj:=0 to Ny-1 do
            for kk:=1 to Ns do
            begin
              HlpInt:=ii-1;
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1]+HlpInt,RelYData[ii,Count-1]-2*HlpInt);
                Lineto (RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Moveto(RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Lineto (RelXdata[Count]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
              end;
            end;
      end; {for ii:=1 to NrOfitems do if PosValues[ii] then}
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end; {if (GroupMark='LrA') or (GroupMark='RrA') then}

    if (GroupMark='It') or (GroupMark='FfA') then
    begin
      Score:=0;                                   {plotting of lines}
      if GroupMark='It' then
         TextOut (PosX1+10,PosY1-15,'Irrigation data in m/season')
      else
         TextOut (PosX1+10,PosY1-15,'Efficiency/sufficiency in %');
      Font.Style := [];
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the parameter values given');
      Font.Style:= [fsBold];
      NrOfObjects:=NrOfItems;
      if GroupMark='FfA' then NrOfObjects:=5;
      for ii:=1 to NrOfObjects do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clGreen;
          Font.Color := clGreen;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'It')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'It*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'FfA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'FfA*'+NameStr);
            end;
          end;
        end;
        if ii=2 then
        begin
          Pen.Color := clFuchsia;
          Font.Color:= clFuchsia;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Is')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Is*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'FfB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'FfB*'+NameStr);
            end;
          end;
        end;
        if ii=3 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Io')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Io*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'FfT')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'FfT*'+NameStr);
            end;
          end;
        end;
        if ii=4 then
        begin
          Pen.Color := clBlue;
          Font.Color:= clBlue;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'IaA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'IaA*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'JsA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'JsA*'+NameStr);
            end;
          end;
        end;
        if ii=5 then
        begin
          Pen.Color := clMaroon;
          Font.Color:= clMaroon;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'IaB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'IaB*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'JsB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'JsB*'+NameStr);
            end;
          end;
        end;
        for jj:=0 to Ny-1 do
            for kk:=1 to Ns do
            begin
              HlpInt:=ii-1;
              if ii=1 then HlpInt:=ii-2;
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1]+HlpInt,RelYData[ii,Count-1]-2*HlpInt);
                Lineto (RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Moveto(RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Lineto (RelXdata[Count]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
              end;
            end;
      end; {for ii:=1 to NrOfitems do if PosValues[ii] then}
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end; {if (GroupMark='It') or (GroupMark='FfA') then}

    if GroupMark='EaU' then
    begin
      Pen.Color := clNavy;
      Font.Color:= clNavy;
      Count:=0;
      TextOut (PosX1+10,PosY1-15,'Actual evaporation from unirrigated land, m/season');
      if FactorY[6]=1 then
         TextOut (PosX1+15,PosY1,'EaU')
      else
      if FactorY[6]=10 then
         TextOut (PosX1+15,PosY1,'EaU*10')
      else
      if FactorY[6]=100 then
         TextOut (PosX1+15,PosY1,'EaU*100');
      for jj:=0 to Ny-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if (Count<NrOfData) then
            begin
              Moveto(RelXdata[Count-1],RelYData[6,Count-1]);
              Lineto (RelXdata[Count-1],RelYdata[6,Count]);
              Moveto(RelXdata[Count-1],RelYdata[6,Count]);
              Lineto (RelXdata[Count],RelYdata[6,Count]);
            end;
         end;
      Font.Color := clMaroon;     {for the text}
    end;{if GroupMark='EaU' then}

    moveto (PosX1,PosY2+4);                         {Axis lines}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);
    AuxFile:=extractfilename (FileName);
    TextOut (70,PosY2+45,'SaltMod: ' + AuxFile);

  end; {with GraphImage.canvas do with DataMod do}

//Restoring original values
  if (DataMod.GroupMark<>'Dw') then
  begin
    for ii:=1 to 7 do if PosValues[ii] then
    if FactorY[ii]>1 then
    begin
      for jj:=0 to DataMod.NrOfData-1 do
        DataMod.Variable[ii,jj]:=DataMod.Variable[ii,jj]/FactorY[ii];
    end;
  end;

  GraphOpened:=true;
  GraphImage.Visible:=true;
  SaveGraph_Button.Enabled:=true;
  ShowSymbolsButton.Enabled:=true;
end; {TMainForm.ShowGraphics}
{---------------------------}





procedure TMainForm.SetInitialDir (AuxDir:string);
{------------------------------------------------}
begin
  MainForm.InputOpen_Dialog.InitialDir:=AuxDir;
  MainForm.InputSave_Dialog.InitialDir:=AuxDir;
  MainForm.OutputOpen_Dialog.InitialDir:=AuxDir;
  MainForm.GraphOpen_Dialog.InitialDir:=AuxDir;
  MainForm.GraphSave_Dialog.InitialDir:=AuxDir;
  MainForm.GroupOpen_Dialog.InitialDir:=AuxDir;
  MainForm.GroupSave_Dialog.InitialDir:=AuxDir;
end; {TMainForm.SetInitialDir}
{----------------------------}




procedure TMainForm.ShowSymbolsButtonClick(Sender: TObject);
begin
  inherited;
  OutputSymbolsForm.Show;
end;



procedure TMainForm.Cancel_ButtonClick(Sender: TObject);
begin
  inherited;
  Panel1.Hide;
end;


{******************************************************************************
 End of Graphics tabsheet, start of CloseForm,
 ******************************************************************************}


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin Inherited;
      Action := caNone;
      CloseForm.Show;
end; {TMainForm.FormClose}



procedure TMainForm.FormShow(Sender: TObject);
begin Inherited;
      If CloseForm.Visible then
            Application.Terminate;
end; {TMainForm.FormShow}


{******************************************************************************
 End of CloseForm, start of MENU ITEMS
 ******************************************************************************}

{Action FileOpen}

procedure TMainForm.InputOpen_Execute(Sender: TObject);
{-----------------------------------------------------}
var InputDir : string;
begin Inherited;
  with DataMod do
  begin
      if MainForm.InputOpen_Dialog.Execute then
      begin
        Filename := MainForm.InputOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
        begin
          ReadInputFile;
//          if Kf=1 then ModernLabel.Visible:=false;
          if Kf=0 then HideEdits else ShowEdits;
          AdjustScreen;
          MakeStrings;
          AdjustScreen;
          AnnualCalc:=false; //Required to enable edit boxes that may have been
                            //disabled during annual calculations
          YI:=0;          //Required after a discontinued previous run with
                         //annual calculations
          YearNr:=0;    //Same
          FirstYear:=true;
(*
          //The following could have been made false under annual calculations
          FileOpen_Button.Enabled := true;
          InputOpen.Enabled := true;
*)
        end else
        begin
           Showmessage ('File does not exist, please select another one,');
           exit;
        end;
      end
      else
      begin
        ShowMessage('No input file was selected');
        exit;
      end;
      WarningForm.Visible:=false;
      FilenameLabel.Caption := FileName;
      FilenameLabel.Show;
      FileName_Label.Show;
      StatusText('Edit the data.  Then use "Save/run", after which'+
                 ' calculations will be done.');
      Title1_Edit.Text:=Title1;
      Title2_Edit.Text:=Title2;
  end; {with DataMod do}
  InputDir:=Getcurrentdir;
  SetInitialDir (InputDir);
  InputSave.Enabled := true;
  InputOpened := true;
end; {TMainForm.InputOpen_Execute}
{--------------------------------}



procedure TMainForm.InputSave_Execute (Sender: TObject);
{------------------------------------------------------}
label 1;
var DataOK, Result : boolean;
    TmpTxt         : textfile;
    Count, k       : byte;

begin Inherited;
   with DataMod do
   begin
1:   if (SetAndVerifySaveName) and not NoSave then
     begin
       Title1 := Title1_Edit.Text;
       Title2 := Title2_Edit.Text;
       DecimalSeparator := InitDecSep;
       MakeValues;
       CheckData(DataOK);
       if not DataOK then exit;
     end
     else
     begin
       Showmessage ('The input data were not saved');
       exit;
     end;
     if not FileExists (FileName) then
     begin
       AssignFile (TmpTxt,FileName);
       rewrite (TmpTxt);
       CloseFile (TmpTxt);
     end;

     DataFile := ExtractFileName (FileName);
     Count:=0;
     for k:=1 to length(DataFile) do
       if DataFile[k]='.' then Count:=Count+1;
     if Count>1 then
     begin
       Showmessage ('The number of dots (.) in the file name'+
                    ' should not be greater than 1. Please adjust.');
       goto 1;
     end;
     WarningForm.Visible:=false;
     if DataMod.YearNr<2 then DataMod.OriginalName:=FileName;
     if DataMod.AnnualCalc then AnnualName:=FileName;
     DataDir := getcurrentdir;
     if DataMod.YearNr<2 then OriginalDir:=DataDir;
     NewDir := ExtractFilePath(FileName);
     OldDir := ExtractFilePath(OriginalName);
     if (OriginalName<>FileName) and AnnualCalc and (YearNr>1) then
        if  NewDir<>OldDir then
        begin
           Deletefile (FileName);
           Showmessage (' During calculations with annual input changes,'+
                        ' the data-path cannot be changed. Please save the'+
                        ' input file in  '+OldDir);
           InputSave_Dialog.InitialDir:=OldDir;
//This does not work, it is difficult to set initialdir effectively
           goto 1;
         end;
     DataDir := getcurrentdir;
     SetInitialDir (DataDir);
     chdir(InitDir);
     if Ky=0 then AnnualCalc := false
     else
     begin
       AnnualCalc:=true;
       EndOfAnnual := false;
     end;
     if FirstYear then
     begin
       First:=1;
       YearNr:=1;
       FirstYear:=false;
       PermanentFile:=FileName;
     end;
     WriteInputFile(FileName);
     WaitMemo.Visible:=true;
     WaitMemo.Lines.Clear;
     WaitMemo.Lines.Add(' Saving the data');
     sleep(500);
     Result := Question('The data were saved in: '+Filename+'. Do you wish'+
                        ' to do the calculations?');
     if not Result then
     begin
       WaitMemo.Lines.Clear;
       WaitMemo.Visible:=false;
       exit;
     end;

     DoCalculations;
     if RuntimeError then exit;
     WaitMemo.Lines.Add(' Finalizing ......');
     Sleep(500);
     WaitMemo.Visible:=false;
     if AnnualCalc and not WTdepth then AnnualMessages;
     if not DataMod.AnnualCalc and not EndOfAnnual then
     begin
       DataFile := ChangeFileExt(FileName,'.INP');
       ShowMessage ('Calculations were done and the output is saved in '
                +   ChangeFileExt(FileName,'.res') +
                '   Use the Output tabsheet to see the results.');
     end;
   end; {with DataMod do}
   if not DataMod.AnnualCalc or DataMod.EndOfAnnual then
   begin
     OutputOpened:=true;
     SaveGroupButton.Visible := false;
     ViewGraph_Button.Visible := false;
     Output_Tabsheet.Show;
   end;
   if WTdepth then if DataMod.AnnualCalc and not DataMod.EndOfAnnual then
   begin
     OutputOpened:=true;
     SaveGroupButton.Visible := false;
     ViewGraph_Button.Visible := false;
     Output_Tabsheet.Show;
   end;

end; {TMainForm.InputSave_Execute}
{--------------------------------}



procedure TMainForm.OutputOpen_Execute(Sender: TObject);
{------------------------------------------------------}
var k : integer;
    ReadingOK : boolean;
begin
  inherited;
    Output_Memo.Visible:=false;
    Panel1.Hide;
    SaveGroupButton.Visible := false;
    ViewGraph_Button.Visible := false;
    with DataMod do
    begin
      if MainForm.OutputOpen_Dialog.Execute then
      begin
        Filename := MainForm.OutputOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
           ReadOutputLines(Filename,ReadingOK)
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No output file was selected');
        OutputOpened:=false;
        exit;
      end;
      StatusText ('Click "Output group" or "Group file" to see graphs.'+
                  ' Alternatively click "Output file" to open an output file' +
                  ' to make graphs.');
      Output_Memo.Lines.Clear;
      for k:=1 to DataMod.NrOfLines do
          Output_Memo.Lines.Add(FileLine[k-1]);
    end; {with DataMod do}
    Output_Memo.Visible:=true;
    OutputOpened := true;
    GroupOpenButton.Visible:=true;
    CloseOutput_Button.Visible:=true;
    OutputSymbols_Button.Visible:=true;
    Group_Button.Visible := true;
    Group_Button.Enabled := true;
    ViewGraph_Button.Visible := false;
    SaltImage1.Visible := false;
    GroupOpened:=false;
    WarningForm.Visible:=false;
    DataDir:=Getcurrentdir;
    SetInitialDir (DataDir);
    Output_Tabsheet.Show;
end; {TMainForm.OutputOpen_Execute}
{---------------------------------}



procedure TMainForm.GroupOpen_Execute(Sender: TObject);
{-----------------------------------------------------}
var i,k : integer;
    ReadingOK : boolean;
begin
  inherited;
      if MainForm.GroupOpen_Dialog.Execute then  with DataMod do
      begin
        Filename := MainForm.GroupOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
        begin
          Output_Memo.Hide;
          ReadOutputLines (FileName,ReadingOK);
          Output_Memo.Lines.Clear;
          for k:=1 to DataMod.NrOfLines do
          begin
            Output_Memo.Lines.Add(FileLine[k-1]);
          end;
          Output_Memo.Show;
          ReadGroupData;
          if DataMod.GroupNotRead then
          begin
            OutputOpened:=false;
            GroupNotRead:=false;
            Output_Tabsheet.Show;
            DataMod.GroupNotRead:=false;
            ViewGraph_Button.Visible := false;
            SaveGroupButton.Visible := false;
            Group_Button.Visible    := false;
            exit;
          end;
          for i:=1 to 7 do PosValues[i]:=false;
          for i:=1 to NrOfitems do for k:=0 to NrOfData-1 do
              if Variable[i,k]>0 then PosValues[i]:=true;
          if GroupMark='Dw' then
          begin
             for k:=0 to NrOfData-1 do
             begin
               setlength (Variable[5],k+1);
               Variable[5,k]:=Variable[1,k];
             end;
             PosValues[5]:=true;
          end;
          ViewGraph_Button.Visible := true;
          SaveGroupButton.Visible := true;
          Group_Button.Visible    := true;
          Group_Button.Enabled    := false;
        end
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          Output_Tabsheet.Show;
          exit;
        end;
      end
      else
      begin
        Showmessage('No output group was selected');
        exit;
      end;
      CloseOutput_Button.Visible:=true;
      OutputSymbols_Button.Visible:=true;
      OutputOpened:=true;
      Output_Tabsheet.Show;
end; {TMainForm.GroupOpen_Execute}
{--------------------------------}



procedure TMainForm.GraphOpen_Execute(Sender: TObject);
{-----------------------------------------------------}
var FigureFile:string;
begin
  inherited;
      GraphOpened := true;
      if MainForm.GraphOpen_Dialog.Execute then  with DataMod do
      begin
        FigureFile := MainForm.GraphOpen_Dialog.Files.Strings[0];
        if FileExists (FigureFile) then
          GraphImage.Picture.LoadFromFile(FigureFile)
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No image file was selected');
        exit;
      end;
      Graphics_Tabsheet.Show;
end; {TMainForm.GraphOpen_Execute}
{--------------------------------}



procedure TMainForm.GraphSave_Execute(Sender: TObject);
{-----------------------------------------------------}
label 1;
var Result : boolean;
    OutputFile : string;
    Count, k   : byte;
begin
  inherited;
    OutputFile:=DataMod.FileName;
1:    if GraphSave_Dialog.Execute then with DataMod do
      begin FileName := GraphSave_Dialog.Files.Strings[0];
        if FileExists(FileName) then
             Result := Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          Count:=0;
          for k:=1 to length(DataMod.FileName) do
              if DataMod.FileName[k]='.' then Count:=Count+1;
          if Count>1 then
          begin
            Showmessage ('The number of dots (.) in the file name'+
                         ' should not be greater than 1. Please adjust.');
            DataMod.FileName:='';
            goto 1;
          end;
          GraphImage.Picture.SaveToFile(FileName);
          Showmessage ('The graph was saved in  ' + Filename);
        end;
      end
      else Showmessage ('The graph was not saved');
    DataMod.FileName:=OutputFile;
end; {TMainForm.GraphSave_Execute}
{--------------------------------}


//werkt niet goed
procedure TMainForm.FilePrint_Execute(Sender: TObject);
begin
  ShellExecute(Handle,'Print','DataMod.FileName',nil,nil,sw_shownormal);
end;


end.






